## scotch 7.0.9

=== CMakeLists.txt ===
## Copyright 2014-2016,2021-2025 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##
############################################################
##                                                        ##
##   AUTHORS    : Marc FUENTES                            ##
##                Florent PRUVOST                         ##
##                                                        ##
##   FUNCTION   : Top-level CMake configuration file      ##
##                                                        ##
##   DATES      : # Version 7.0  : from : 18 jan 2022     ##
##                                 to     02 aug 2025     ##
##                                                        ##
############################################################

cmake_minimum_required(VERSION 3.10)

project(SCOTCH LANGUAGES C)

# Use C99 as C standard
set(CMAKE_C_STANDARD 99)

# Set MPI components depending on language support
set(MPI_COMPONENTS C)

# Add Fortran support
option(BUILD_FORTRAN "Enable Fortran" ON)
if(BUILD_FORTRAN)
  enable_language(Fortran)
  if(NOT CMAKE_Fortran_COMPILER)
    message(ERROR "Fortran enabled but no compiler detected")
  endif()
  list(APPEND MPI_COMPONENTS Fortran)
endif()

# Add module directory
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules)

set(SCOTCH_VERSION 7)
set(SCOTCH_RELEASE 0)
set(SCOTCH_PATCHLEVEL 9)
set(SCOTCH_CODENAME "Sankara")

add_definitions(-DSCOTCH_VERSION_NUM=${SCOTCH_VERSION}
  -DSCOTCH_RELEASE_NUM=${SCOTCH_RELEASE}
  -DSCOTCH_PATCHLEVEL_NUM=${SCOTCH_PATCHLEVEL})

set(SCOTCH_VERSION_LONG "${SCOTCH_VERSION}.${SCOTCH_RELEASE}.${SCOTCH_PATCHLEVEL}")

# Set integer size: by default, use compiler int size
set(INTSIZE "" CACHE STRING "Integer size: empty string stands for C compiler int type size")

# Set index size: by default, use compiler int size
set(IDXSIZE "" CACHE STRING "Index size: empty string stands for C compiler int type size")

# Manage suffixes
set(SCOTCH_NAME_SUFFIX "" CACHE STRING "Suffix to add to every symbol in the Scotch/PT-Scotch libraries")
if(NOT "${SCOTCH_NAME_SUFFIX}" STREQUAL "")
  set(USE_SUFFIX ON)
endif()
# Thread support
option(THREADS "Use multi-threading in Scotch and PT-Scotch" ON)

# Use MPI with threads
option(MPI_THREAD_MULTIPLE "Use multi-threading with MPI in PT-Scotch" ON)

# Build PT-Scotch
option(BUILD_PTSCOTCH "Build PT-Scotch" ON)

# Build libESMUMPS
option(BUILD_LIBESMUMPS "Build EsMUMPS library" ON)

# Build libScotchMeTiS
option(BUILD_LIBSCOTCHMETIS "Build ScotchMeTiS library" ON)

# Prefix Scotch version of MeTiS routines
option(SCOTCH_METIS_PREFIX "Prefix Scotch version of MeTiS routines" OFF)

# Install our MeTiS header stubs
option(INSTALL_METIS_HEADERS "Install libScotchMeTiS headers in destination directory" ON)

# Level of deterministic behavior
set(SCOTCH_DETERMINISTIC "FIXED_SEED" CACHE STRING "Level of determinism in Scotch")
set_property(CACHE SCOTCH_DETERMINISTIC PROPERTY STRINGS NONE FIXED_SEED FULL)

# Compression format options
option(USE_ZLIB "Use ZLIB compression format if found" ON)
option(USE_LZMA "Use LZMA compression format if found" ON)
option(USE_BZ2 "Use BZ2 compression format if found" ON)

# Set fPIC flag when building shared libraries
set(CMAKE_POSITION_INDEPENDENT_CODE ${BUILD_SHARED_LIBS})

# scotcherr option
set(LIBSCOTCHERR "" CACHE STRING "Which error library is linked by default")
set(LIBPTSCOTCHERR "" CACHE STRING "Which parallel error library is linked by default")

# Allow for testing
option(ENABLE_TESTS "Enable testing" ON)
if(ENABLE_TESTS)
  enable_testing()
endif(ENABLE_TESTS)

# use GNU standard for file hierarchy installation system
include(GNUInstallDirs)

add_subdirectory(src)

# Install man pages
set(scotch_man_pages
acpl.1
amk_ccc.1
amk_grf.1
atst.1
gbase.1
gcv.1
gdump.1
gmap.1
gmk_hy.1
gmk_m2.1
gmk_msh.1
gmtst.1
gord.1
gotst.1
gout.1
gtst.1
mcv.1
mmk_m2.1
mord.1
mtst.1
)
foreach(f IN LISTS scotch_man_pages)
  install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/man1/${f}
    DESTINATION ${CMAKE_INSTALL_DATADIR}/man/man1 COMPONENT scotch)
endforeach()

if(BUILD_PTSCOTCH)
  set(ptscotch_man_pages dgmap.1 dgord.1 dgscat.1 dgtst.1)
  foreach(f IN LISTS ptscotch_man_pages)
    install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/man1/${f}
      DESTINATION ${CMAKE_INSTALL_DATADIR}/man/man1 COMPONENT ptscotch)
  endforeach()
endif(BUILD_PTSCOTCH)

=== src/CMakeLists.txt ===
## Copyright 2014-2016,2021-2025 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##
############################################################
##                                                        ##
##   AUTHORS    : Marc FUENTES                            ##
##                Florent PRUVOST                         ##
##                Cedric LACHAT (v6.0)                    ##
##                Amaury JACQUES (v6.0)                   ##
##                Clement BARTHELEMY                      ##
##                                                        ##
##   FUNCTION   : Secondary configuration file for CMake  ##
##                                                        ##
##   DATES      : # Version 6.0  : from : 01 sep 2014     ##
##                                 to     01 sep 2021     ##
##                # Version 7.0  : from : 01 sep 2021     ##
##                                 to     28 aug 2025     ##
##                                                        ##
############################################################

# Add general compiler options
add_definitions(-Drestrict=__restrict -DSCOTCH_RENAME)

set(dev_null /dev/null)

# Add OS-specific compiler options
if(APPLE)
  add_definitions(-DCOMMON_OS_MACOS -D_DARWIN_C_SOURCE)
endif(APPLE)
if(MINGW OR MSYS OR WIN32)
  add_definitions(-DCOMMON_OS_WINDOWS)
  set(dev_null NUL)
endif(MINGW OR MSYS OR WIN32)
if(MSVC)
  add_definitions(-D_CRT_NONSTDC_NO_WARNINGS -D_CRT_SECURE_NO_WARNINGS)
endif(MSVC)

# Detect FreeBSD
if(${CMAKE_HOST_SYSTEM_NAME}} MATCHES "^.*FreeBSD.*$")
  set(OS_IS_FREEBSD ON)
  message(STATUS "OS is FreeBSD")
endif()

# Manage suffixes
if (USE_SUFFIX)
  add_definitions(-DSCOTCH_RENAME_ALL -DSCOTCH_NAME_SUFFIX=${SCOTCH_NAME_SUFFIX})
endif()

###################
#  Prerequisites  #
###################

# Bison
find_package(BISON)
if(NOT BISON_FOUND)
  message(WARNING "Compiling with a default version of parser files. Install Bison >= 3.8.2 if it does not work")
else()
  message(STATUS "Bison found here: ${BISON_EXECUTABLE}")
endif()

# Flex
find_package(FLEX)
if (FLEX_VERSION VERSION_EQUAL "2.6.1")
  message(WARNING "Flex 2.6.1 is bogus")
  set(FLEX_FOUND FALSE)
endif()
if(NOT FLEX_FOUND)
  message(WARNING "Compiling with a default version of lexer files. Install Flex >= 2.6.4 if it does not work")
else()
  message(STATUS "Flex found here: ${FLEX_EXECUTABLE}")
endif()

if(WIN32)
  set(FLEX_FLAG "--wincompat")
else()
  set(FLEX_FLAG "")
endif()

#############
#  Options  #
#############

# Set integer size
if(NOT INTSIZE STREQUAL "")
  if(INTSIZE STREQUAL "32")
    message(STATUS "Integer size is 32 bits")
    add_definitions(-DINTSIZE32)
  elseif(INTSIZE STREQUAL "64")
    message(STATUS "Integer size is 64 bits")
    add_definitions(-DINTSIZE64)
  else()
    message(FATAL_ERROR "Invalid integer size value")
  endif()
endif()

# Set index size
if(NOT IDXSIZE STREQUAL "")
  if(IDXSIZE STREQUAL "32")
    message(STATUS "Index size is 32 bits")
    add_definitions(-DIDXSIZE32)
  elseif(IDXSIZE STREQUAL "64")
    message(STATUS "Index size is 64 bits")
    add_definitions(-DIDXSIZE64)
  else()
    message(FATAL_ERROR "Invalid integer size value")
  endif()
endif()

# Thread support in Scotch
if(THREADS)
  find_package(Threads)
  if(Threads_FOUND)
    add_definitions(-DCOMMON_PTHREAD -DSCOTCH_PTHREAD)
  endif()
  if(CMAKE_USE_WIN32_THREADS_INIT)
    add_definitions(-DCOMMON_THREAD_WIN32)
  endif()
  include(CheckPthreadAffinity)
  if(PTHREAD_AFFINITY_LINUX_OK)
    add_definitions(-DCOMMON_PTHREAD_AFFINITY_LINUX)
  endif()
endif()

# Detect and remove GCC _FORTIFY_SOURCE
if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
  message(WARNING "GCC _FORTIFY_SOURCE is known to cause problem with Scotch and is disabled by default")
  set(CMAKE_C_FLAGS "-U_FORTIFY_SOURCE ${CMAKE_C_FLAGS}")
endif()

# Decompression libs
if(USE_ZLIB)
  find_package(ZLIB)
endif(USE_ZLIB)

if (USE_BZ2)
  find_package(BZip2)
endif (USE_BZ2)

if (USE_LZMA)
  find_package(LibLZMA)
endif(USE_LZMA)

# MPI
if(BUILD_PTSCOTCH)
  set(MPI_DETERMINE_LIBRARY_VERSION ON)
  find_package(MPI COMPONENTS ${MPI_COMPONENTS})
  if(NOT MPI_C_FOUND)
    message(FATAL_ERROR "MPI required to compile PT-Scotch\n Rerun cmake with -DBUILD_PTSCOTCH=OFF")
  else()
    string(REGEX MATCHALL "\( Open MPI \)+" found_suite ${MPI_C_LIBRARY_VERSION_STRING})
    if(NOT ${found_suite} STREQUAL "")
      message(STATUS "Found OpenMPI: using '--oversubscribe' policy for testing")
      set(MPIEXEC_PREFLAGS ${MPIEXEC_PREFLAGS} --oversubscribe)
    endif()
    string(REGEX MATCHALL "\(Intel\)+" found_suite ${MPI_C_LIBRARY_VERSION_STRING})
    if(NOT ${found_suite} STREQUAL "")
      message(STATUS "Found Intel MPI: using '-genv=I_MPI_PIN_DOMAIN=core' for testing")
      set(MPIEXEC_PREFLAGS ${MPIEXEC_PREFLAGS} -genv=I_MPI_PIN_DOMAIN=core)
    endif()
  endif()

  if(MPI_THREAD_MULTIPLE)
    if(Threads_FOUND)
      include(CheckMpiThreadMultiple)
      if(MPI_THREAD_MULTIPLE_OK)
        message(STATUS "MPI implementation DOES support MPI_THREAD_MULTIPLE")
        add_definitions(-DSCOTCH_PTHREAD_MPI)
      else()
        message(STATUS "MPI implementation does NOT support MPI_THREAD_MULTIPLE")
      endif()
    endif()
  endif()
endif(BUILD_PTSCOTCH)

# Put libraries in the lib subdirectory
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)

# Put executables in the bin subdirectory
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

# Set variables for include directories
set(GENERATED_INCLUDE_DIR ${CMAKE_CURRENT_BINARY_DIR}/include)
set(LIBSCOTCH_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/libscotch)
file(MAKE_DIRECTORY ${GENERATED_INCLUDE_DIR})

# Build Scotch and PT-Scotch libraries
add_subdirectory(libscotch)
# Build Scotch executables
add_subdirectory(scotch)

# Build EsMUMPS library
if(BUILD_LIBESMUMPS AND NOT USE_SUFFIX)
  add_subdirectory(esmumps)
endif(BUILD_LIBESMUMPS AND NOT USE_SUFFIX)

# Build ScotchMeTiS library
if(BUILD_LIBSCOTCHMETIS)
  add_subdirectory(libscotchmetis)
endif(BUILD_LIBSCOTCHMETIS)

# Testing
if(ENABLE_TESTS)
  add_subdirectory(check)
endif(ENABLE_TESTS)

####################
#  Export targets  #
####################

# See https://cmake.org/cmake/help/latest/module/CMakePackageConfigHelpers.html
include(CMakePackageConfigHelpers)

configure_package_config_file(${PROJECT_SOURCE_DIR}/cmake/SCOTCHConfig.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/SCOTCHConfig.cmake
  INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/scotch
  PATH_VARS CMAKE_INSTALL_INCLUDEDIR CMAKE_INSTALL_LIBDIR)

write_basic_package_version_file(SCOTCHConfigVersion.cmake
  VERSION ${SCOTCH_VERSION_LONG}
  COMPATIBILITY AnyNewerVersion)

# Install config files
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/SCOTCHConfig.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/SCOTCHConfigVersion.cmake
  COMPONENT libscotch
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/scotch)

=== src/Makefile ===
## Copyright 2004,2007,2008,2010-2012,2014,2018-2025 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##

VERSION	= 7
RELEASE = 0
PATCHLEVEL = 9
CODENAME = "Sankara"

.PHONY				:	clean	default	install	ptscotch	realclean	required	scotch

default				:	scotch

required			:	Makefile.inc	../bin	../include	../lib

Makefile.inc			:
					@echo "#####################################################################"
			        	@echo "BEFORE COMPILING Scotch OR PT-Scotch, YOU SHOULD HAVE AN APPROPRIATE"
					@echo "Makefile.inc FILE IN THIS DIRECTORY. PLEASE LOOK INTO DIRECTORY"
	        			@echo " ./Make.inc FOR AN EXISTING Makefile.inc FILE THAT FITS YOUR NEED, OR"
		        		@echo "USE THEM AS MODELS IN CASE YOU NEED TO BUILD A NEW ONE FOR YOUR"
		        		@echo "PARTICULAR PLATFORM."
			        	@echo "#####################################################################"
			        	@echo "Then, type \"make scotch\" (default) for the sequential library"
			        	@echo "and software, or \"make ptscotch\" for the parallel library and"
			        	@echo "software."
					@exit 1

include Makefile.inc

prefix		?= /usr/local
bindir		?= $(prefix)/bin
includedir	?= $(prefix)/include
includestub     ?= include_stub
includestubdir	?= $(prefix)/$(includestub)
libdir		?= $(prefix)/lib
datarootdir	?= $(prefix)/share
mandir		?= $(datarootdir)/man

../bin				:
					-$(MKDIR) ../bin

../include			:
					-$(MKDIR) ../include

../lib				:
					-$(MKDIR) ../lib

$(bindir)			:
					-$(MKDIR) $(bindir)

$(datarootdir)			:
					-$(MKDIR) $(datarootdir)

$(includedir)			:
					-$(MKDIR) $(includedir)
					-$(MKDIR) $(includestubdir)

$(libdir)			:
					-$(MKDIR) $(libdir)

$(mandir)			:	$(datarootdir)
					-$(MKDIR) $(mandir)

$(mandir)/man1			:	$(mandir)
					-$(MKDIR) $(mandir)/man1

libscotch			:	required
					(cd libscotch ;      $(MAKE) VERSION=$(VERSION) RELEASE=$(RELEASE) PATCHLEVEL=$(PATCHLEVEL) scotch && $(MAKE) install)

scotch				:	libscotch
					(cd scotch ;         $(MAKE) VERSION=$(VERSION) RELEASE=$(RELEASE) PATCHLEVEL=$(PATCHLEVEL) CODENAME=$(CODENAME) scotch && $(MAKE) install)
					(cd libscotchmetis ; $(MAKE)                                                                scotch && $(MAKE) install)

libptscotch			:	libscotch
					(cd libscotch ;      $(MAKE) VERSION=$(VERSION) RELEASE=$(RELEASE) PATCHLEVEL=$(PATCHLEVEL) ptscotch && $(MAKE) ptinstall)

ptscotch			:	libptscotch
					(cd scotch ;         $(MAKE) VERSION=$(VERSION) RELEASE=$(RELEASE) PATCHLEVEL=$(PATCHLEVEL) CODENAME=$(CODENAME) ptscotch && $(MAKE) ptinstall)
					(cd libscotchmetis ; $(MAKE)                                                                ptscotch && $(MAKE) ptinstall)

check				:	scotch
					(cd check ; $(MAKE) check)

check_full			:	scotch
					(cd check ; $(MAKE) check_full)

ptcheck				:	ptscotch
					(cd check ; $(MAKE) ptcheck)

ptcheck_full			:	ptscotch
					(cd check ; $(MAKE) ptcheck_full)

esmumps				:	scotch
					(cd esmumps ; $(MAKE) scotch && $(MAKE) install)

escheck				:	esmumps
					(cd check ; $(MAKE) escheck)

ptesmumps			:	scotch	ptscotch
					(cd esmumps ; $(MAKE) ptscotch && $(MAKE) ptinstall)

install				:	required	$(bindir)	$(includedir)	$(libdir)	$(mandir)/man1
					-$(CP) -f ../bin/[agm]*$(EXE) $(bindir)
					-$(CP) -f ../bin/d[agm]*$(EXE) $(bindir)
					-$(CP) -f ../include/*esmumps*.h $(includedir)
					-$(CP) -f ../include/*scotch*.h $(includedir)
					-$(CP) -f ../lib/*esmumps*$(LIB) $(libdir)
					-$(CP) -f ../lib/*scotch*$(LIB) $(libdir)
					-$(CP) -f ../man/man1/*[.]1 $(mandir)/man1

installstub			:	required	$(includedir)
					-$(CP) -f ../include/*metis*.h $(includestubdir)

clean				:	required
					(cd libscotch ;      $(MAKE) clean)
					(cd scotch ;         $(MAKE) clean)
					(cd libscotchmetis ; $(MAKE) clean)
					(cd check ;          $(MAKE) clean)
					(cd esmumps ;        $(MAKE) clean)

realclean			:	required
					(cd libscotch ;      $(MAKE) realclean)
					(cd scotch ;         $(MAKE) realclean)
					(cd libscotchmetis ; $(MAKE) realclean)
					(cd check ;          $(MAKE) realclean)
					(cd esmumps ;        $(MAKE) realclean)
					-$(RM) ../bin/* ../include/* ../lib/*

=== src/check/CMakeLists.txt ===
## Copyright 2014-2016,2021,2022,2024,2025 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##
############################################################
##                                                        ##
##   AUTHORS    : Marc FUENTES                            ##
##                Florent PRUVOST                         ##
##                Cedric LACHAT                           ##
##                Amaury JACQUES                          ##
##                Xavier MULLER                           ##
##                Francois PELLEGRINI                     ##
##                                                        ##
##   FUNCTION   : Secondary configuration file for CMake  ##
##                                                        ##
##   DATES      : # Version 6.0  : from : 01 sep 2014     ##
##                                 to     01 sep 2021     ##
##                # Version 7.0  : from : 01 sep 2021     ##
##                                 to     18 jul 2025     ##
##                                                        ##
############################################################

# Set directory aliases

set(dat ${CMAKE_CURRENT_SOURCE_DIR}/data)
set(tgt ${PROJECT_SOURCE_DIR}/tgt)

# Macro to add quickly a Scotch test executable

function(add_test_scotch)
  add_executable(${ARGV0} ${ARGV0}.c)
  set_target_properties(${ARGV0} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
  target_link_libraries(${ARGV0} PRIVATE scotch scotcherr)
  if(CMAKE_BUILD_TYPE STREQUAL Debug)
    target_compile_definitions(${ARGV0} PRIVATE SCOTCH_DEBUG_ALL)
  endif()
  if(${ARGC} GREATER_EQUAL 2)
    add_test(NAME ${ARGV0} COMMAND ${ARGV0})
  endif()
endfunction(add_test_scotch)

# Macro to suffix a fortran test file

function(suffix_fortran_file src)
  get_filename_component(file_we ${src} NAME_WLE)
  add_custom_command(OUTPUT
    ${CMAKE_CURRENT_BINARY_DIR}/${file_we}.tmp
    COMMAND
    $<TARGET_FILE:dummysizes> "-s${SCOTCH_NAME_SUFFIX}"
    ${CMAKE_CURRENT_SOURCE_DIR}/${file_we}.in
    ${CMAKE_CURRENT_BINARY_DIR}/${file_we}.tmp
    DEPENDS
    dummysizes
    DEPENDS
    ${CMAKE_CURRENT_SOURCE_DIR}/${file}
    COMMENT "Generate ${file}.f90")

  add_custom_target(${file_we}_tmp ALL
    DEPENDS
    "${CMAKE_CURRENT_BINARY_DIR}/${file_we}.tmp")

  file(WRITE
    "${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/CMakeTmp/cmake_sed_${file_we}.cmake"
"
file(READ \"${file_we}.tmp\" FILE_CONTENTS)
string(REGEX REPLACE \"SCOTCHMETISNAMEFU *\\\\(([A-Za-z0-9_]*)\\\\)\" \"\${SCOTCH_METIS_PREFIXFU}\\\\1\" FILE_CONTENTS \"\${FILE_CONTENTS}\")
file(WRITE \"\${CMAKE_CURRENT_BINARY_DIR}/${file_we}\" \"\${FILE_CONTENTS}\")
"
)

  add_custom_command(
    OUTPUT
      ${CMAKE_CURRENT_BINARY_DIR}/${file_we}
    COMMAND
      ${CMAKE_COMMAND} -P ${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/CMakeTmp/cmake_sed_${file_we}.cmake
    DEPENDS
      ${file_we}_tmp
  )
  add_custom_target(${file_we}_src ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${file_we})
endfunction(suffix_fortran_file)

# Bash needed for running some tests

include(FindUnixCommands)

#######################################
#  Tests of the sequential libraries  #
#######################################

# test_common_file_compress

add_test_scotch(test_common_file_compress)
set(_map_bz2 "BZIP2")
set(_map_gz "ZLIB")
set(_map_lzma "LIBLZMA")
foreach(ext "bz2" "gz" "lzma")
  if(${_map_${ext}}_FOUND)
    set(cur ${CMAKE_CURRENT_BINARY_DIR})
    add_test(NAME test_common_file_compress_${ext} COMMAND ${BASH} -c
      "'$<TARGET_FILE:test_common_file_compress>' ${dat}/bump_b1.grf ${cur}/bump_b1.grf.${ext} && \
      '$<TARGET_FILE:test_common_file_compress>' ${cur}/bump_b1.grf.${ext} ${cur}/bump_b1_from_${ext}.grf && \
      '${CMAKE_COMMAND}' -E compare_files ${cur}/bump_b1_from_${ext}.grf ${dat}/bump_b1.grf")
  endif(${_map_${ext}}_FOUND)
endforeach()

# test_common_random

add_test_scotch(test_common_random)

add_test(NAME test_common_random COMMAND ${BASH} -c
        "'$<TARGET_FILE:test_common_random>' ${CMAKE_CURRENT_BINARY_DIR}/rand.dat 0 && \
         '$<TARGET_FILE:test_common_random>' ${CMAKE_CURRENT_BINARY_DIR}/rand.dat 1")

# test_common_thread

add_test_scotch(test_common_thread 1)

# test_fibo

add_test_scotch(test_fibo 1)

# Test EsMumps

if(BUILD_LIBESMUMPS AND NOT USE_SUFFIX)
  add_executable(test_libesmumps test_libesmumps.c)
  add_dependencies(test_libesmumps esmumps_h)
  set_target_properties(test_libesmumps PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
  target_include_directories(test_libesmumps PRIVATE ${GENERATED_INCLUDE_DIR})
  target_link_libraries(test_libesmumps scotch esmumps scotcherr)
  add_test(NAME test_libesmumps_1 COMMAND $<TARGET_FILE:test_libesmumps> ${dat}/bump.grf)
  add_test(NAME test_libesmumps_2 COMMAND $<TARGET_FILE:test_libesmumps> ${dat}/bump_imbal_32.grf)
endif(BUILD_LIBESMUMPS AND NOT USE_SUFFIX)

# Test libScotchMeTiS

if(BUILD_LIBSCOTCHMETIS)
  # manage prefix
  if(NOT SCOTCH_METIS_PREFIXFU)
    if(NOT SCOTCH_METIS_PREFIX)
      set(SCOTCH_METIS_PREFIXFU "")
    else()
      set(SCOTCH_METIS_PREFIXFU "SCOTCHF")
    endif(NOT SCOTCH_METIS_PREFIX)
  endif(NOT SCOTCH_METIS_PREFIXFU)

  suffix_fortran_file(test_libmetis_dual_f.f90.in)
  foreach(version 3 5)
    add_executable(test_libmetisv${version} test_libmetis.c)
    set_target_properties(test_libmetisv${version} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
    target_compile_definitions(test_libmetisv${version} PRIVATE SCOTCH_METIS_VERSION=${version})
    target_include_directories(test_libmetisv${version} PRIVATE ${GENERATED_INCLUDE_DIR})
    target_link_libraries(test_libmetisv${version} scotchmetisv${version} scotch scotcherr)

    add_test(NAME test_libmetisv${version}_1 COMMAND $<TARGET_FILE:test_libmetisv${version}> ${dat}/bump.grf)

    add_test(NAME test_libmetisv${version}_2 COMMAND $<TARGET_FILE:test_libmetisv${version}> ${dat}/bump_b1.grf)

    add_test(NAME test_libmetisv${version}_3 COMMAND $<TARGET_FILE:test_libmetisv${version}> ${dat}/bump_imbal_32.grf)

    add_executable(test_libmetis_dualv${version} test_libmetis_dual.c)
    target_compile_definitions(test_libmetis_dualv${version} PRIVATE SCOTCH_METIS_VERSION=${version})
    target_include_directories(test_libmetis_dualv${version} PRIVATE ${GENERATED_INCLUDE_DIR})
    target_link_libraries(test_libmetis_dualv${version} scotchmetisv${version} scotch scotcherr)

    add_test(NAME test_libmetis_dualv${version} COMMAND test_libmetis_dualv${version})

    add_test(NAME test_libmetis_dualv${version}_2 COMMAND test_libmetis_dualv${version} 1)

    if(BUILD_FORTRAN)
      add_executable(test_libmetis_dual_f_v${version} ${CMAKE_CURRENT_BINARY_DIR}/test_libmetis_dual_f.f90)
      target_compile_definitions(test_libmetis_dual_f_v${version} PRIVATE SCOTCH_METIS_VERSION=${version})
      target_include_directories(test_libmetis_dual_f_v${version} PRIVATE ${GENERATED_INCLUDE_DIR})
      target_link_libraries(test_libmetis_dual_f_v${version} scotch scotchmetisv${version} scotcherr)

      add_test(NAME test_libmetis_dual_f_v${version} COMMAND test_libmetis_dual_f_v${version})
    endif()
  endforeach(version 3 5)
endif(BUILD_LIBSCOTCHMETIS)

# test_scotch_arch

add_test_scotch(test_scotch_arch)

add_test(NAME test_scotch_arch COMMAND test_scotch_arch arch.tgt)

# test_scotch_arch_deco

add_test_scotch(test_scotch_arch_deco)

add_test(NAME test_scotch_arch_deco COMMAND test_scotch_arch_deco ${dat}/m4x4.grf arch2.tgt)

# test_scotch_context

add_test_scotch(test_scotch_context)

add_test(NAME test_scotch_context COMMAND test_scotch_context ${dat}/bump_b1.grf)
if(Threads_FOUND)
  target_link_libraries(test_scotch_context PRIVATE Threads::Threads ${THREADS_PTHREADS_WIN32_LIBRARY})
endif(Threads_FOUND)

# test_graph_coarsen

add_test_scotch(test_scotch_graph_coarsen)

add_test(NAME test_scotch_graph_coarsen_1 COMMAND test_scotch_graph_coarsen ${dat}/bump.grf)

add_test(NAME test_scotch_graph_coarsen_2 COMMAND test_scotch_graph_coarsen ${dat}/bump_b100000.grf)

# test_graph_color

add_test_scotch(test_scotch_graph_color)

add_test(NAME test_scotch_graph_color_1 COMMAND test_scotch_graph_color ${dat}/bump.grf)

add_test(NAME test_scotch_graph_color_2 COMMAND test_scotch_graph_color ${dat}/bump_b100000.grf)

# test_graph_diam

add_test_scotch(test_scotch_graph_diam)

add_test(NAME test_scotch_graph_diam_1 COMMAND test_scotch_graph_diam ${dat}/bump.grf)

add_test(NAME test_scotch_graph_diam_2 COMMAND test_scotch_graph_diam ${dat}/m16x16_b1.grf)

add_test(NAME test_scotch_graph_diam_3 COMMAND test_scotch_graph_diam ${dat}/p2-p2.grf)

add_test(NAME test_scotch_graph_diam_4 COMMAND test_scotch_graph_diam ${dat}/bump_b100000.grf)

# test_graph_dump

add_custom_command(OUTPUT m16x16_b1.c
  COMMAND $<TARGET_FILE:gdump> -ptest ${dat}/m16x16_b1.grf ${CMAKE_CURRENT_BINARY_DIR}/m16x16_b1.c)

add_custom_command(OUTPUT test_scotch_graph_dump2.c
  COMMAND ${CMAKE_COMMAND} -E cat ${CMAKE_CURRENT_SOURCE_DIR}/test_scotch_graph_dump.c m16x16_b1.c > test_scotch_graph_dump2.c
  DEPENDS m16x16_b1.c)

add_test_scotch(test_scotch_graph_dump2)

add_test(NAME test_scotch_graph_dump COMMAND ${BASH} -c
  "'$<TARGET_FILE:test_scotch_graph_dump2>' 'm16x16_b1_dump2.grf' && \
   '${CMAKE_COMMAND}' -E compare_files '${dat}/m16x16_b1.grf' m16x16_b1_dump2.grf")

# test_graph_induce

add_test_scotch(test_scotch_graph_induce)

add_test(NAME test_scotch_graph_induce_1 COMMAND test_scotch_graph_induce ${dat}/bump.grf)

add_test(NAME test_scotch_graph_induce_2 COMMAND test_scotch_graph_induce ${dat}/bump_b100000.grf)

# test_scotch_graph_map

add_test_scotch(test_scotch_graph_map)

add_test(NAME test_scotch_graph_1 COMMAND test_scotch_graph_map ${dat}/m4x4.grf)

add_test(NAME test_scotch_graph_2 COMMAND test_scotch_graph_map ${dat}/m4x4_b100000.grf)

add_test(NAME test_scotch_graph_3 COMMAND test_scotch_graph_map ${dat}/m16x16.grf)

add_test(NAME test_scotch_graph_4 COMMAND test_scotch_graph_map ${dat}/m16x16_b100000.grf)

# test_scotch_graph_map_copy

add_test_scotch(test_scotch_graph_map_copy)

add_test(NAME test_scotch_graph_map_copy_1 COMMAND test_scotch_graph_map_copy ${dat}/bump.grf)

add_test(NAME test_scotch_graph_map_copy_2 COMMAND test_scotch_graph_map_copy ${dat}/bump_b100000.grf)

# test_scotch_graph_order

add_test_scotch(test_scotch_graph_order)

=== src/check/Makefile ===
## Copyright 2011,2012,2014-2016,2018-2021,2024,2025 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##

TMPDIR			?= /tmp

SCOTCHBINDIR		?= ../../bin
SCOTCHINCLUDEDIR	?= ../../include
SCOTCHLIBDIR		?= ../../lib
SCOTCHTGTDIR		?= ../../tgt

LIBESMUMPS		= -lesmumps -lscotch -lscotcherr
LIBPTSCOTCH		= -lptscotch -lscotch -lptscotcherr
LIBSCOTCH		= -lscotch -lscotcherr

DEPESMUMPS		= $(SCOTCHLIBDIR)/libesmumps$(LIB)
DEPPTSCOTCH		= $(SCOTCHLIBDIR)/libptscotch$(LIB)
DEPSCOTCH		= $(SCOTCHLIBDIR)/libscotch$(LIB)

include ../Makefile.inc

ifeq ($(strip $(SCOTCH_NAME_SUFFIX)),)
  ifneq ($(findstring -DSCOTCH_NAME_SUFFIX=,$(CFLAGS)),)
    scotch_name_suffix_defs = $(filter -DSCOTCH_NAME_SUFFIX=%,$(CFLAGS))
    scotch_name_suffix_def = $(lastword $(scotch_name_suffix_defs))
    export SCOTCH_NAME_SUFFIX = $(subst -DSCOTCH_NAME_SUFFIX=,,$(scotch_name_suffix_def))
  endif
endif
ifneq ($(strip $(SCOTCH_NAME_SUFFIX)),)
  $(info Using suffix "$(SCOTCH_NAME_SUFFIX)")
  ifeq ($(findstring -DSCOTCH_NAME_SUFFIX=,$(CFLAGS)),)
    CFLAGS += -DSCOTCH_NAME_SUFFIX=$(SCOTCH_NAME_SUFFIX)
  endif
  ifeq ($(findstring -DSCOTCH_NAME_SUFFIX=,$(CCDFLAGS)),)
    CCDFLAGS += -DSCOTCH_NAME_SUFFIX=$(SCOTCH_NAME_SUFFIX)
  endif
endif

ifeq ($(strip $(SCOTCH_METIS_PREFIXFU)),)
  ifneq ($(findstring -DSCOTCH_METIS_PREFIXFU=,$(CFLAGS)),)
    scotch_metis_prefixfu_defs = $(filter -DSCOTCH_METIS_PREFIXFU=%,$(CFLAGS))
    scotch_metis_prefixfu_def = $(lastword $(scotch_metis_prefixfu_defs))
    export SCOTCH_METIS_PREFIXFU = $(subst -DSCOTCH_METIS_PREFIXFU=,,$(scotch_metis_prefixfu_def))
  endif
endif
ifeq ($(strip $(SCOTCH_METIS_PREFIXFU)),)
  ifeq ($(findstring -DSCOTCH_METIS_PREFIX,$(CFLAGS)),)
    export SCOTCH_METIS_PREFIXFU =
  else
    export SCOTCH_METIS_PREFIXFU = SCOTCHF
  endif
endif
ifneq ($(strip $(SCOTCH_METIS_PREFIXFU)),)
  $(info Using MeTiS uppercase Fortran prefix "$(SCOTCH_METIS_PREFIXFU)")
endif

EXECPPROG		?= mpirun
EXECPFLAGS		?= $(if $(findstring Open,$(shell $(EXECPPROG) --version)),--oversubscribe)
# EXECPFLAGS		+= valgrind --leak-check=full --show-leak-kinds=all --track-origins=yes
EXECS			?=
# EXECS			+= valgrind --leak-check=full --show-leak-kinds=all --track-origins=yes
EXECP3			?= $(EXECPPROG) -n 3 $(EXECPFLAGS)
EXECP4			?= $(EXECPPROG) -n 4 $(EXECPFLAGS)

PROGDIFF		?= diff -q
PROGSED			?= sed

##
##  General inference rules.
##

%$(OBJ)	:	%.c
				$(CC) $(CFLAGS) $(CLIBFLAGS) -I$(SCOTCHINCLUDEDIR) -c $(<) -o $(@)

%_v3$(EXE) :	%.c
				$(CC) $(CFLAGS) -I$(SCOTCHINCLUDEDIR) -L$(SCOTCHLIBDIR) $(<) -o $(@) -lscotchmetisv3 $(SCOTCHLIBS) $(LDFLAGS)

%_v5$(EXE) :	%.c
				$(CC) $(CFLAGS) -I$(SCOTCHINCLUDEDIR) -L$(SCOTCHLIBDIR) $(<) -o $(@) -lscotchmetisv5 $(SCOTCHLIBS) $(LDFLAGS)

%$(EXE)	:	%.c
				$(CC) $(CFLAGS) -I$(SCOTCHINCLUDEDIR) -L$(SCOTCHLIBDIR) $(<) -o $(@) $(SCOTCHLIBS) $(LDFLAGS)

%.f90	:	%.f90.in
				../libscotch/dummysizes$(EXE) -s$(SCOTCH_NAME_SUFFIX) $(<) $(@).tmp
				$(PROGSED) -e 's/SCOTCHMETISNAMEFU\s*(\([A-Za-z0-9_]*\))/'"$(SCOTCH_METIS_PREFIXFU)"'\1/g' $(@).tmp > $(@)

%_v3$(EXE):	%.f90
				$(FC) $(FFLAGS) -I$(SCOTCHINCLUDEDIR) -L$(SCOTCHLIBDIR) $(<) -o $(@) -lscotchmetisv3 $(SCOTCHLIBS) $(LDFLAGS)

%_v5$(EXE):	%.f90
				$(FC) $(FFLAGS) -I$(SCOTCHINCLUDEDIR) -L$(SCOTCHLIBDIR) $(<) -o $(@) -lscotchmetisv5 $(SCOTCHLIBS) $(LDFLAGS)

##
##  Project rules.
##

.PHONY				:	check	ptcheck	clean	realclean	nothing

nothing				:

check				:	realclean
					$(MAKE) CC="$(CCS)" CCD="$(CCS)" SCOTCHLIBS="$(LIBSCOTCH)" $(CHECKSCOTCH)
					$(MAKE) CC="$(CCS)" CCD="$(CCS)" FC="$(FCS)" SCOTCHLIBS="$(LIBSCOTCH)" $(CHECKSCOTCHF)

check_full			:	realclean
					$(MAKE) CC="$(CCS) -DSCOTCH_DEBUG_FULL" CCD="$(CCS)" SCOTCHLIBS="$(LIBSCOTCH)" check_prog_full

ptcheck				:	realclean
					$(MAKE) CFLAGS="$(CFLAGS) -DSCOTCH_PTSCOTCH" CC="$(CCP)" SCOTCHLIBS="$(LIBPTSCOTCH)" $(CHECKPTSCOTCH)

ptcheck_full			:	realclean
					$(MAKE) CFLAGS="$(CFLAGS) -DSCOTCH_PTSCOTCH" CC="$(CCP)" SCOTCHLIBS="$(LIBPTSCOTCH)" check_prog_dfull

escheck				:	realclean
					$(MAKE) CFLAGS="$(CFLAGS)" CC="$(CCP)" SCOTCHLIBS="$(LIBESMUMPS)" $(CHECKESMUMPS)

clean				:
					-$(RM) *~ *$(OBJ)

realclean			:	clean
					-$(RM) 				\
					test_common_file_compress	\
					test_common_random		\
					test_common_thread		\
					test_fibo			\
					test_libesmumps			\
					test_libmetis_v3		\
					test_libmetis_v5		\
					test_libmetis_dual_v3		\
					test_libmetis_dual_v5		\
					test_libmetis_dual_f.f90	\
					test_libmetis_dual_f.f90.tmp	\
					test_libmetis_dual_f_v3		\
					test_libmetis_dual_f_v5		\
					test_scotch_arch		\
					test_scotch_arch_deco		\
					test_scotch_context		\
					test_scotch_graph_coarsen	\
					test_scotch_graph_color		\
					test_scotch_graph_diam		\
					test_scotch_graph_dump2		\
					test_scotch_graph_dump2.c	\
					test_scotch_graph_induce	\
					test_scotch_graph_map		\
					test_scotch_graph_map_copy	\
					test_scotch_graph_order		\
					test_scotch_graph_part_ovl	\
					test_scotch_dgraph_band		\
					test_scotch_dgraph_check	\
					test_scotch_dgraph_coarsen	\
					test_scotch_dgraph_grow		\
					test_scotch_dgraph_induce	\
					test_scotch_dgraph_redist	\
					test_scotch_mesh_graph		\
					test_strat_par			\
					test_strat_seq

##
##  Test cases dependencies.
##

CHECKSCOTCH = 		check_common_file_compress		\
			check_common_random			\
			check_common_thread			\
			check_fibo				\
			check_strat_seq				\
			check_scotch_arch			\
			check_scotch_arch_deco			\
			check_scotch_context			\
			check_scotch_graph_coarsen		\
			check_scotch_graph_color		\
			check_scotch_graph_diam			\
			check_scotch_graph_dump			\
			check_scotch_graph_induce		\
			check_scotch_graph_map			\
			check_scotch_graph_map_copy		\
			check_scotch_graph_order		\
			check_scotch_graph_part_ovl		\
			check_scotch_mesh_graph			\
			check_libmetis_v3			\
			check_libmetis_v5			\
			check_libmetis_dual_v3			\
			check_libmetis_dual_v5			\
			check_prog_amk				\
			check_prog_amk_grf			\
			check_prog_acpl				\
			check_prog_gbase			\
			check_prog_gmap				\
			check_prog_gmk				\
			check_prog_gmk_msh			\
			check_prog_gord				\
			check_prog_gord_block			\
			check_prog_gotst			\
			check_prog_gout				\
			check_prog_gpart			\
			check_prog_gpart_clustering		\
			check_prog_gpart_overlap		\
			check_prog_gpart_remap			\
			check_prog_gscat			\
			check_prog_gtst				\
			check_prog_mmk				\
			check_prog_mord

CHECKSCOTCHF = 		check_libmetis_dual_f_v3		\
			check_libmetis_dual_f_v5

ifeq ($(strip $(FCS)),)
  CHECKSCOTCHF =	nothing
endif

CHECKPTSCOTCH = 	check_strat_par				\
			check_scotch_dgraph_check		\
			check_scotch_dgraph_band		\
			check_scotch_dgraph_coarsen		\
			check_scotch_dgraph_grow		\
			check_scotch_dgraph_induce     		\
			check_scotch_dgraph_redist		\
			check_libparmetis_dual          	\
			check_prog_dgord			\
			check_prog_dgpart			\
			check_prog_dgscat-dggath		\
			check_prog_dgtst

CHECKESMUMPS = 		check_libesmumps

##
##  Sequential library tests.
##

check_common_file_compress	:	test_common_file_compress
					-cp "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf"
					$(EXECS) ./test_common_file_compress "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf.gz"
					$(EXECS) ./test_common_file_compress "$(TMPDIR)/bump_b1.grf.gz" "$(TMPDIR)/bump_b1.grf"
					$(PROGDIFF) "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf"
					-cp "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf"
					$(EXECS) ./test_common_file_compress "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf.bz2"
					$(EXECS) ./test_common_file_compress "$(TMPDIR)/bump_b1.grf.bz2" "$(TMPDIR)/bump_b1.grf"
					$(PROGDIFF) "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf"
					-cp "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf"
					$(EXECS) ./test_common_file_compress "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf.lzma"
					$(EXECS) ./test_common_file_compress "$(TMPDIR)/bump_b1.grf.lzma" "$(TMPDIR)/bump_b1.grf"
					$(PROGDIFF) "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf"

test_common_file_compress	:	test_common_file_compress.c	\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_common_random		:	test_common_random
					$(EXECS) ./test_common_random "$(TMPDIR)/rand.dat" 0
					$(EXECS) ./test_common_random "$(TMPDIR)/rand.dat" 1

test_common_random		:	test_common_random.c		\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_common_thread		:	test_common_thread
					$(EXECS) ./test_common_thread

test_common_thread		:	test_common_thread.c		\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_fibo			:	test_fibo
					$(EXECS) ./test_fibo

test_fibo			:	test_fibo.c			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_libesmumps		:	test_libesmumps
					$(EXECS) ./test_libesmumps data/bump.grf
					$(EXECS) ./test_libesmumps data/bump_imbal_32.grf

test_libesmumps			:	test_libesmumps.c		\
					$(SCOTCHLIBDIR)/libscotch$(LIB)	\
					$(SCOTCHLIBDIR)/libesmumps$(LIB)

##

check_libmetis_v3		:	test_libmetis_v3
					$(EXECS) ./test_libmetis_v3 data/bump.grf
					$(EXECS) ./test_libmetis_v3 data/bump_b1.grf
					$(EXECS) ./test_libmetis_v3 data/bump_imbal_32.grf

test_libmetis_v3		:	test_libmetis.c			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)	\
					$(SCOTCHLIBDIR)/libscotchmetisv3$(LIB)

check_libmetis_v5		:	test_libmetis_v5
					$(EXECS) ./test_libmetis_v5 data/bump.grf
					$(EXECS) ./test_libmetis_v5 data/bump_b1.grf
					$(EXECS) ./test_libmetis_v5 data/bump_imbal_32.grf

test_libmetis_v5		:	test_libmetis.c			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)	\
					$(SCOTCHLIBDIR)/libscotchmetisv5$(LIB)

##

check_libmetis_dual_v3		:	test_libmetis_dual_v3
					$(EXECS) ./test_libmetis_dual_v3
					$(EXECS) ./test_libmetis_dual_v3 1

test_libmetis_dual_v3		:	test_libmetis_dual.c		\
					$(SCOTCHLIBDIR)/libscotch$(LIB)	\
					$(SCOTCHLIBDIR)/libscotchmetisv3$(LIB)

check_libmetis_dual_v5		:	test_libmetis_dual_v5
					$(EXECS) ./test_libmetis_dual_v5
					$(EXECS) ./test_libmetis_dual_v5 1

test_libmetis_dual_v5		:	test_libmetis_dual.c		\
					$(SCOTCHLIBDIR)/libscotch$(LIB)	\
					$(SCOTCHLIBDIR)/libscotchmetisv5$(LIB)

##

check_libmetis_dual_f_v3	:	test_libmetis_dual_f_v3
					$(EXECS) ./test_libmetis_dual_f_v3

test_libmetis_dual_f_v3		:	test_libmetis_dual_f.f90	\
					$(SCOTCHLIBDIR)/libscotch$(LIB)	\
					$(SCOTCHLIBDIR)/libscotchmetisv3$(LIB)

check_libmetis_dual_f_v5	:	test_libmetis_dual_f_v5
					$(EXECS) ./test_libmetis_dual_f_v5

test_libmetis_dual_f_v5		:	test_libmetis_dual_f.f90	\
					$(SCOTCHLIBDIR)/libscotch$(LIB)	\
					$(SCOTCHLIBDIR)/libscotchmetisv5$(LIB)

=== src/libscotch/CMakeLists.txt ===
## Copyright 2014-2016,2021-2025 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##
############################################################
##                                                        ##
##   AUTHORS    : Cedric LACHAT                           ##
##                Amaury JACQUES                          ##
##                Florent PRUVOST                         ##
##                Marc FUENTES                            ##
##                                                        ##
##   FUNCTION   : Secondary configuration file for CMake  ##
##                                                        ##
##   DATES      : # Version 6.0  : from : 01 sep 2014     ##
##                                 to     01 sep 2021     ##
##                # Version 7.0  : from : 01 sep 2021     ##
##                                 to     11 aug 2025     ##
##                                                        ##
############################################################

################
#  dummysizes  #
################

add_executable(dummysizes dummysizes.c)
set_target_properties(dummysizes PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
if(BUILD_PTSCOTCH)
  add_executable(ptdummysizes dummysizes.c)
  set_target_properties(ptdummysizes PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
  target_link_libraries(ptdummysizes PRIVATE MPI::MPI_C)
  add_dependencies(ptdummysizes scotch_h)
  set_target_properties(ptdummysizes PROPERTIES
    COMPILE_FLAGS -DSCOTCH_PTSCOTCH)
endif()

##############
#  scotch.h  #
##############

# Generate scotch.h
add_custom_command(OUTPUT ${GENERATED_INCLUDE_DIR}/scotch.h
  COMMAND $<TARGET_FILE:dummysizes> "-s${SCOTCH_NAME_SUFFIX}"
  ${CMAKE_CURRENT_SOURCE_DIR}/library.h ${GENERATED_INCLUDE_DIR}/scotch.h DEPENDS dummysizes
  DEPENDS library.h
  COMMENT "Generate scotch.h")
add_custom_target(scotch_h
  DEPENDS "${GENERATED_INCLUDE_DIR}/scotch.h")

# Generate scotchf.h
add_custom_command(OUTPUT ${GENERATED_INCLUDE_DIR}/scotchf.h
  COMMAND $<TARGET_FILE:dummysizes>  "-s${SCOTCH_NAME_SUFFIX}"
  ${CMAKE_CURRENT_SOURCE_DIR}/library_f.h ${GENERATED_INCLUDE_DIR}/scotchf.h DEPENDS dummysizes
  DEPENDS library.h
  COMMENT "Generate scotchf.h")
add_custom_target(scotchf_h
  DEPENDS "${GENERATED_INCLUDE_DIR}/scotchf.h")

################
#  ptscotch.h  #
################

# Generate ptscotch.h
if(BUILD_PTSCOTCH)
  add_custom_command(OUTPUT ${GENERATED_INCLUDE_DIR}/ptscotch.h
    COMMAND $<TARGET_FILE:ptdummysizes> "-s${SCOTCH_NAME_SUFFIX}"
    ${CMAKE_CURRENT_SOURCE_DIR}/library_pt.h ${GENERATED_INCLUDE_DIR}/ptscotch.h DEPENDS ptdummysizes
    DEPENDS library_pt.h scotch_h
    COMMENT "Generate ptscotch.h")
  add_custom_target(ptscotch_h
    DEPENDS ${GENERATED_INCLUDE_DIR}/ptscotch.h)

# Generate ptscotchf.h
add_custom_command(OUTPUT ${GENERATED_INCLUDE_DIR}/ptscotchf.h
  COMMAND $<TARGET_FILE:ptdummysizes> "-s${SCOTCH_NAME_SUFFIX}"
  ${CMAKE_CURRENT_SOURCE_DIR}/library_pt_f.h ${GENERATED_INCLUDE_DIR}/ptscotchf.h DEPENDS ptdummysizes
  DEPENDS library.h
  COMMENT "Generate ptscotchf.h")
add_custom_target(ptscotchf_h
  DEPENDS "${GENERATED_INCLUDE_DIR}/ptscotchf.h")
endif()

#################
#  parser_yy.c  #
#################

if (BISON_FOUND)
  # Generate parser_yy.c using Bison
  add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/parser_yy.c ${CMAKE_CURRENT_BINARY_DIR}/parser_ly.h
    COMMAND ${BISON_EXECUTABLE} "-p_SCOTCHyy${SCOTCH_NAME_SUFFIX}" --defines="parser_ly.h" --output="parser_yy.c" ${CMAKE_CURRENT_SOURCE_DIR}/parser_yy.y
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/parser_yy.y module.h common.h parser.h parser_yy.h
    COMMENT "Generate parser_yy.c and parser_ly.h using Bison")
else()
  # use fallback
  add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/parser_yy.c ${CMAKE_CURRENT_BINARY_DIR}/parser_ly.h
    COMMAND cp "${CMAKE_CURRENT_SOURCE_DIR}/last_resort/parser_yy.c" "${CMAKE_CURRENT_SOURCE_DIR}/last_resort/parser_ly.h" "${CMAKE_CURRENT_BINARY_DIR}/.")
endif(BISON_FOUND)
add_custom_target(parser_yy_c DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/parser_yy.c ${CMAKE_CURRENT_BINARY_DIR}/parser_ly.h)

#################
#  parser_ll.c  #
#################

if (FLEX_FOUND)
  # Generate parser_ll.c using Flex
  add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/parser_ll.c
    ${CMAKE_CURRENT_BINARY_DIR}/parser_lh.h
    COMMAND ${FLEX_EXECUTABLE} "${FLEX_FLAG}" "-P_SCOTCHyy${SCOTCH_NAME_SUFFIX}"  "-oparser_ll.c"
    "--header-file=parser_lh.h"
    ${CMAKE_CURRENT_SOURCE_DIR}/parser_ll.l
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/parser_ll.l
    module.h common.h parser.h parser_ll.h parser_ly.h
    COMMENT "Generate parser_ll.c using Flex")
else()
  # use fallback
  add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/parser_ll.c ${CMAKE_CURRENT_BINARY_DIR}/parser_lh.h
    COMMAND cp "${CMAKE_CURRENT_SOURCE_DIR}/last_resort/parser_ll.c" "${CMAKE_CURRENT_SOURCE_DIR}/last_resort/parser_lh.h" "${CMAKE_CURRENT_BINARY_DIR}/.")
endif(FLEX_FOUND)
add_custom_target(parser_ll_c DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/parser_ll.c ${CMAKE_CURRENT_BINARY_DIR}/parser_lh.h)

###############
#  libScotch  #
###############

set(SCOTCH_C_SOURCES
  arch.c
  arch.h
  arch_build.c
  arch_build.h
  arch_build2.c
  arch_build2.h
  arch_cmplt.c
  arch_cmplt.h
  arch_cmpltw.c
  arch_cmpltw.h
  arch_deco.c
  arch_deco.h
  arch_deco2.c
  arch_deco2.h
  arch_dist.c
  arch_dist.h
  arch_hcub.c
  arch_hcub.h
  arch_mesh.c
  arch_mesh.h
  arch_tleaf.c
  arch_tleaf.h
  arch_sub.c
  arch_sub.h
  arch_torus.c
  arch_torus.h
  arch_vcmplt.c
  arch_vcmplt.h
  arch_vhcub.c
  arch_vhcub.h
  bgraph.c
  bgraph.h
  bgraph_bipart_bd.c
  bgraph_bipart_bd.h
  bgraph_bipart_df.c
  bgraph_bipart_df.h
  bgraph_bipart_ex.c
  bgraph_bipart_ex.h
  bgraph_bipart_fm.c
  bgraph_bipart_fm.h
  bgraph_bipart_gg.c
  bgraph_bipart_gg.h
  bgraph_bipart_gp.c
  bgraph_bipart_gp.h
  bgraph_bipart_ml.c
  bgraph_bipart_ml.h
  bgraph_bipart_st.c
  bgraph_bipart_st.h
  bgraph_bipart_zr.c
  bgraph_bipart_zr.h
  bgraph_cost.c
  bgraph_check.c
  bgraph_cost.c
  bgraph_store.c
  common.c
  common.h
  common_context.c
  common_error.c
  common_file.c
  common_file.h
  common_file_compress.c
  common_file_compress.h
  common_file_decompress.c
  common_integer.c
  common_memory.c
  common_string.c
  common_stub.c
  common_thread.c
  common_thread_system.c
  common_thread_system.h
  common_timer.c
  common_timer.h
  common_values.c
  common_values.h
  context.c
  context.h
  fibo.c
  fibo.h
  gain.c
  gain.h
  geom.c
  geom.h
  graph.c
  graph.h
  graph_band.c
  graph_base.c
  graph_check.c
  graph_clone.c
  graph_coarsen.c
  graph_coarsen.h
  graph_diam.c
  graph_dump.c
  graph_dump.h
  graph_ielo.c
  library_graph_induce.c
  graph_induce.c
  graph_induce.h
  graph_io.c
  graph_io.h
  graph_io_chac.c
  graph_io_habo.c
  graph_io_habo.h
  graph_io_mmkt.c
  graph_io_mmkt.h
  graph_io_scot.c
  graph_io_scot.h
  graph_list.c
  graph_list.h
  graph_match.c
  graph_match.h
  hall_order_hd.c
  hall_order_hd.h
  hall_order_hf.c
  hall_order_hf.h
  hall_order_hx.c
  hall_order_hx.h
  hgraph.c
  hgraph.h
  hgraph_check.c
  hgraph_induce.c
  hgraph_induce.h
  hgraph_order_bl.c
  hgraph_order_bl.h
  hgraph_order_cc.c
  hgraph_order_cc.h
  hgraph_order_cp.c
  hgraph_order_cp.h
  hgraph_order_gp.c
  hgraph_order_gp.h
  hgraph_order_hd.c
  hgraph_order_hd.h
  hgraph_order_hf.c
  hgraph_order_hf.h
  hgraph_order_hx.c
  hgraph_order_hx.h
  hgraph_order_kp.c
  hgraph_order_kp.h
  hgraph_order_nd.c
  hgraph_order_nd.h
  hgraph_order_si.c
  hgraph_order_si.h
  hgraph_order_st.c
  hgraph_order_st.h
  hmesh.c
  hmesh.h
  hmesh_check.c
  hmesh_hgraph.c
  hmesh_hgraph.h
  hmesh_induce.c
  hmesh_mesh.c
  hmesh_order_bl.c
  hmesh_order_bl.h
  hmesh_order_cp.c
  hmesh_order_cp.h
  hmesh_order_gp.c
  hmesh_order_gp.h
  hmesh_order_gr.c
  hmesh_order_gr.h
  hmesh_order_hd.c
  hmesh_order_hd.h
  hmesh_order_hf.c
  hmesh_order_hf.h
  hmesh_order_hx.c
  hmesh_order_hx.h
  hmesh_order_nd.c
  hmesh_order_nd.h
  hmesh_order_si.c
  hmesh_order_si.h
  hmesh_order_st.c
  hmesh_order_st.h
  kgraph.c
  kgraph.h
  kgraph_band.c
  kgraph_check.c
  kgraph_cost.c
  kgraph_map_bd.c
  kgraph_map_bd.h
  kgraph_map_cp.c
  kgraph_map_cp.h
  kgraph_map_df.c
  kgraph_map_df.h
  kgraph_map_ex.c
  kgraph_map_ex.h
  kgraph_map_fm.c
  kgraph_map_fm.h
  kgraph_map_ml.c
  kgraph_map_ml.h
  kgraph_map_rb.c
  kgraph_map_rb.h
  kgraph_map_rb_map.c
  kgraph_map_rb_map.h
  kgraph_map_rb_part.c
  kgraph_map_rb_part.h
  kgraph_map_st.c
  kgraph_map_st.h
  kgraph_store.c
  library.h
  library_arch.c
  library_arch_build.c
  library_arch_build_f.c
  library_arch_dom.c
  library_arch_dom_f.c
  library_arch_f.c
  library_common.c
  library_common_f.c
  library_context.c
  library_context_graph.c
  library_context_graph_f.c
  library_context_f.c
  #library_errcom.c
  #library_error.c
  #library_error_exit.c
  library_f.h
  library_geom.c
  library_geom_f.c
  library_graph.c
  library_graph_base.c
  library_graph_base_f.c
  library_graph_check.c
  library_graph_check_f.c
  library_graph_coarsen.c
  library_graph_coarsen_f.c
  library_graph_color.c
  library_graph_color_f.c
  library_graph_diam.c
  library_graph_diam_f.c
  library_graph_dump.c
  library_graph_f.c
  library_graph_io_chac.c
  library_graph_io_chac_f.c
  library_graph_io_habo.c
  library_graph_io_habo_f.c
  library_graph_io_mmkt.c
  library_graph_io_mmkt_f.c
  library_graph_io_scot.c
  library_graph_io_scot_f.c
  library_graph_map.c
  library_graph_map_f.c
  library_graph_map_io.c
  library_graph_map_io.h
  library_graph_map_io_f.c
  library_graph_map_view.c
  library_graph_map_view.h
  library_graph_map_view_f.c
  library_graph_order.c
  library_graph_order_f.c
  library_graph_part_ovl.c
  library_graph_part_ovl_f.c
  library_mapping.c
  library_mapping.h
  library_memory.c
  library_mesh.c
  library_mesh_f.c
  library_mesh_graph.c
  library_mesh_graph_f.c
  library_mesh_io_habo.c
  library_mesh_io_habo_f.c
  library_mesh_io_scot.c
  library_mesh_io_scot_f.c
  library_mesh_order.c
  library_mesh_order_f.c
  library_order.c
  library_order.h
  library_parser.c
  library_parser_f.c
  library_pt.h
  library_pt_f.h
  library_random.c
  library_random_f.c
  library_strat.c
  library_version.c
  library_version_f.c
  mapping.c
  mapping.h
  mapping_check.c
  mapping_io.c
  mapping_io.h
  mesh.c
  mesh.h
  mesh_check.c

=== src/libscotch/Makefile ===
## Copyright 2004,2007-2021,2023-2025 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##

SCOTCHINCLUDEDIR	?= ../../include
SCOTCHLIBDIR		?= ../../lib

include ../Makefile.inc

CCDFLAGS ?= $(CFLAGS)

ifeq ($(strip $(SCOTCH_NAME_SUFFIX)),)
  ifneq ($(findstring -DSCOTCH_NAME_SUFFIX=,$(CFLAGS)),)
    scotch_name_suffix_defs = $(filter -DSCOTCH_NAME_SUFFIX=%,$(CFLAGS))
    scotch_name_suffix_def = $(lastword $(scotch_name_suffix_defs))
    export SCOTCH_NAME_SUFFIX = $(subst -DSCOTCH_NAME_SUFFIX=,,$(scotch_name_suffix_def))
  endif
endif
ifneq ($(strip $(SCOTCH_NAME_SUFFIX)),)
  $(info Using suffix "$(SCOTCH_NAME_SUFFIX)")
  ifeq ($(findstring -DSCOTCH_NAME_SUFFIX=,$(CFLAGS)),)
    CFLAGS += -DSCOTCH_NAME_SUFFIX=$(SCOTCH_NAME_SUFFIX)
  endif
  ifeq ($(findstring -DSCOTCH_RENAME_ALL=,$(CFLAGS)),)
    CFLAGS += -DSCOTCH_RENAME_ALL
  endif
  ifeq ($(findstring -DSCOTCH_NAME_SUFFIX=,$(CCDFLAGS)),)
    CCDFLAGS += -DSCOTCH_NAME_SUFFIX=$(SCOTCH_NAME_SUFFIX)
  endif
  ifeq ($(findstring -DSCOTCH_RENAME_ALL=,$(CCDFLAGS)),)
    CCDFLAGS += -DSCOTCH_RENAME_ALL
  endif
endif

## Manage Flex 2.6.1 bug

ifneq ($(strip $(FLEX)),)
  ifneq ($(findstring 2.6.1,$(shell $(FLEX) --version)),)
    $(warning WARNING: Flex 2.6.1 is bogus)
    FLEX =
  endif
endif

ifeq ($(strip $(FLEX)),)
  $(warning WARNING: Compiling with a default version of lexer files. Install Flex >= 2.6.4 if it does not work)
  FLEX = false blockoptions
endif
ifeq ($(strip $(BISON)),)
  $(warning WARNING: Compiling with a default version of parser files. Install Bison >= 3.8.2 if it does not work)
  BISON = false blockoptions
endif

##
##  General inference rules.
##

%$(OBJ)	:	%.c
					$(CC) $(CFLAGS) $(CLIBFLAGS) -c $(<) -o $(@) -DSCOTCH_VERSION_NUM=$(VERSION) -DSCOTCH_RELEASE_NUM=$(RELEASE) -DSCOTCH_PATCHLEVEL_NUM=$(PATCHLEVEL)

%$(EXE)	:	%.c
					$(CC) $(CFLAGS) -DSCOTCH_VERSION_NUM=$(VERSION) -DSCOTCH_RELEASE_NUM=$(RELEASE) -DSCOTCH_PATCHLEVEL_NUM=$(PATCHLEVEL) $(<) -o $(@) $(LDFLAGS)

##
##  Project rules.
##

.PHONY				:	ptscotch	scotch	ptinstall	install	clean	realclean

scotch				:
					$(MAKE) 					\
					CC="$(CCS)"					\
					CCD="$(CCS)"					\
					scotch.h					\
					scotchf.h					\
					libscotch$(LIB)					\
					libscotcherr$(LIB)				\
					libscotcherrexit$(LIB)

ptscotch			:	scotch
					$(MAKE) 					\
					CC="$(CCP)"					\
					CFLAGS="$(CFLAGS) -DSCOTCH_PTSCOTCH"		\
					CCDFLAGS="$(CCDFLAGS) -DSCOTCH_PTSCOTCH"	\
					ptscotch.h					\
					ptscotchf.h					\
					libptscotch$(LIB)				\
					libptscotcherr$(LIB)				\
					libptscotcherrexit$(LIB)

install				:	$(SCOTCHINCLUDEDIR)/scotch.h			\
					$(SCOTCHINCLUDEDIR)/scotchf.h			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

ptinstall			:	install						\
					$(SCOTCHINCLUDEDIR)/ptscotch.h			\
					$(SCOTCHINCLUDEDIR)/ptscotchf.h			\
					$(SCOTCHLIBDIR)/libptscotch$(LIB)

clean				:
					-$(RM) *~ *$(OBJ) lib*$(LIB) parser_yy.c parser_lh.h parser_ly.h parser_ll.c parser_yy.c *scotch.h *scotchf.h y.output *dummysizes$(EXE)

realclean			:	clean


##
##  Installation dependencies
##

$(SCOTCHINCLUDEDIR)/scotch.h		:	scotch.h
						-$(CP) scotch.h $(SCOTCHINCLUDEDIR)

$(SCOTCHINCLUDEDIR)/scotchf.h		:	scotchf.h
						-$(CP) scotchf.h $(SCOTCHINCLUDEDIR)

$(SCOTCHINCLUDEDIR)/ptscotch.h		:	ptscotch.h
						-$(CP) ptscotch.h $(SCOTCHINCLUDEDIR)

$(SCOTCHINCLUDEDIR)/ptscotchf.h		:	ptscotchf.h
						-$(CP) ptscotchf.h $(SCOTCHINCLUDEDIR)

$(SCOTCHLIBDIR)/libscotch$(LIB)		:	libscotch$(LIB)
						-$(CP) libscotch$(LIB) libscotcherr*$(LIB) $(SCOTCHLIBDIR)

$(SCOTCHLIBDIR)/libptscotch$(LIB)	:	libptscotch$(LIB)
						-$(CP) libptscotch$(LIB) libptscotcherr*$(LIB) $(SCOTCHLIBDIR)

##
##  Library dependencies.
##

LIBPTSCOTCHDEPS =	arch_mpi$(OBJ)				\
			arch_cmplt_mpi$(OBJ)			\
			arch_cmpltw_mpi$(OBJ)			\
			arch_deco_mpi$(OBJ)			\
			arch_deco2_mpi$(OBJ)			\
			arch_dist_mpi$(OBJ)			\
			arch_hcub_mpi$(OBJ)			\
			arch_mesh_mpi$(OBJ)			\
			arch_sub_mpi$(OBJ)			\
			arch_tleaf_mpi$(OBJ)			\
			arch_vcmplt_mpi$(OBJ)			\
			arch_vhcub_mpi$(OBJ)			\
			bdgraph$(OBJ)				\
			bdgraph_bipart_bd$(OBJ)			\
			bdgraph_bipart_df$(OBJ)			\
			bdgraph_bipart_ex$(OBJ)			\
			bdgraph_bipart_ml$(OBJ)			\
			bdgraph_bipart_sq$(OBJ)			\
			bdgraph_bipart_st$(OBJ)			\
			bdgraph_bipart_zr$(OBJ)			\
			bdgraph_check$(OBJ)			\
			bdgraph_gather_all$(OBJ)		\
			bdgraph_store$(OBJ)			\
			comm$(OBJ)				\
			dgraph$(OBJ)				\
			dgraph_allreduce$(OBJ)			\
			dgraph_band$(OBJ)			\
			dgraph_build$(OBJ)			\
			dgraph_build_grid3d$(OBJ)		\
			dgraph_build_hcub$(OBJ)			\
			dgraph_check$(OBJ)			\
			dgraph_coarsen$(OBJ)			\
			dgraph_compact$(OBJ)			\
			dgraph_fold$(OBJ)			\
			dgraph_fold_comm$(OBJ)			\
			dgraph_fold_dup$(OBJ)			\
			dgraph_gather$(OBJ)			\
			dgraph_gather_all$(OBJ)			\
			dgraph_ghst$(OBJ)			\
			dgraph_halo$(OBJ)			\
			dgraph_induce$(OBJ)			\
			dgraph_io_load$(OBJ)			\
			dgraph_io_save$(OBJ)			\
			dgraph_match$(OBJ)			\
			dgraph_match_sync_coll$(OBJ)		\
			dgraph_match_sync_ptop$(OBJ)		\
			dgraph_match_check$(OBJ)		\
			dgraph_redist$(OBJ)			\
			dgraph_scatter$(OBJ)			\
			dgraph_view$(OBJ)			\
			dmapping$(OBJ)				\
			dmapping_io$(OBJ)			\
			dmesh$(OBJ)				\
			dmesh_build_adm$(OBJ)			\
			dmesh_dgraph$(OBJ)			\
			dmesh_io_load$(OBJ)			\
			dorder$(OBJ)				\
			dorder_gather$(OBJ)			\
			dorder_io$(OBJ)				\
			dorder_io_block$(OBJ)			\
			dorder_io_tree$(OBJ)			\
			dorder_perm$(OBJ)			\
			dorder_tree_dist$(OBJ)			\
			hdgraph$(OBJ)				\
			hdgraph_check$(OBJ)			\
			hdgraph_fold$(OBJ)			\
			hdgraph_gather$(OBJ)			\
			hdgraph_induce$(OBJ)			\
			hdgraph_order_nd$(OBJ)			\
			hdgraph_order_si$(OBJ)			\
			hdgraph_order_sq$(OBJ)			\
			hdgraph_order_st$(OBJ)			\
			kdgraph$(OBJ)				\
			kdgraph_gather$(OBJ)			\
			kdgraph_map_rb$(OBJ)			\
			kdgraph_map_rb_map$(OBJ)		\
			kdgraph_map_rb_part$(OBJ)		\
			kdgraph_map_st$(OBJ)			\
			library_context_dgraph$(OBJ)		\
			library_context_dgraph_f$(OBJ)		\
			library_dgraph$(OBJ)			\
			library_dgraph_f$(OBJ)			\
			library_dgraph_band$(OBJ)		\
			library_dgraph_band_f$(OBJ)		\
			library_dgraph_build$(OBJ)		\
			library_dgraph_build_f$(OBJ)		\
			library_dgraph_build_grid3d$(OBJ)	\
			library_dgraph_build_grid3d_f$(OBJ)	\
			library_dgraph_check$(OBJ)		\
			library_dgraph_check_f$(OBJ)		\
			library_dgraph_coarsen$(OBJ)		\
			library_dgraph_coarsen_f$(OBJ)		\
			library_dgraph_gather$(OBJ)		\
			library_dgraph_gather_f$(OBJ)		\
			library_dgraph_grow$(OBJ)		\
			library_dgraph_halo$(OBJ)		\
			library_dgraph_halo_f$(OBJ)		\
			library_dgraph_induce$(OBJ)		\
			library_dgraph_induce_f$(OBJ)		\
			library_dgraph_io_load$(OBJ)		\
			library_dgraph_io_load_f$(OBJ)		\
			library_dgraph_io_save$(OBJ)		\
			library_dgraph_io_save_f$(OBJ)		\
			library_dgraph_map$(OBJ)		\
			library_dgraph_map_f$(OBJ)		\
			library_dgraph_map_stat$(OBJ)		\
			library_dgraph_map_stat_f$(OBJ)		\
			library_dgraph_map_view$(OBJ)		\
			library_dgraph_map_view_f$(OBJ)		\
			library_dgraph_order$(OBJ)		\
			library_dgraph_order_f$(OBJ)		\
			library_dgraph_order_gather$(OBJ)	\
			library_dgraph_order_gather_f$(OBJ)	\
			library_dgraph_order_io$(OBJ)		\
			library_dgraph_order_io_f$(OBJ)		\
			library_dgraph_order_io_block$(OBJ)	\
			library_dgraph_order_io_block_f$(OBJ)	\
			library_dgraph_order_perm$(OBJ)		\
			library_dgraph_order_perm_f$(OBJ)	\
			library_dgraph_order_tree_dist$(OBJ)	\
			library_dgraph_order_tree_dist_f$(OBJ)	\
			library_dgraph_redist$(OBJ)		\
			library_dgraph_redist_f$(OBJ)		\
			library_dgraph_scatter$(OBJ)		\
			library_dgraph_scatter_f$(OBJ)		\
			library_dgraph_stat$(OBJ)		\
			library_dgraph_stat_f$(OBJ)		\
			library_dmapping$(OBJ)			\
			library_dmesh$(OBJ)			\
			library_dmesh_f$(OBJ)			\
			library_dmesh_build_adm$(OBJ)		\
			library_dmesh_build_adm_f$(OBJ)		\
			library_dmesh_dgraph$(OBJ)		\
			library_dmesh_dgraph_f$(OBJ)		\
			library_dmesh_io_load$(OBJ)		\
			library_dmesh_io_load_f$(OBJ)		\
			library_dorder$(OBJ)			\
			vdgraph$(OBJ)				\
			vdgraph_check$(OBJ)			\
			vdgraph_gather_all$(OBJ)		\
			vdgraph_separate_bd$(OBJ)		\
			vdgraph_separate_df$(OBJ)		\
			vdgraph_separate_ml$(OBJ)		\
			vdgraph_separate_sq$(OBJ)		\
			vdgraph_separate_st$(OBJ)		\
			vdgraph_separate_zr$(OBJ)		\
			vdgraph_store$(OBJ)

LIBSCOTCHDEPS	=	arch$(OBJ)				\
			arch_build$(OBJ)			\
			arch_build2$(OBJ)			\
			arch_cmplt$(OBJ)			\
			arch_cmpltw$(OBJ)			\
			arch_deco$(OBJ)				\
			arch_deco2$(OBJ)			\
			arch_dist$(OBJ)				\
			arch_hcub$(OBJ)				\
			arch_mesh$(OBJ)				\
			arch_sub$(OBJ)				\
			arch_tleaf$(OBJ)			\
			arch_torus$(OBJ)			\
			arch_vcmplt$(OBJ)			\
			arch_vhcub$(OBJ)			\
			bgraph$(OBJ)				\
			bgraph_bipart_bd$(OBJ)			\
			bgraph_bipart_df$(OBJ)			\
			bgraph_bipart_ex$(OBJ)			\
			bgraph_bipart_fm$(OBJ)			\
			bgraph_bipart_gg$(OBJ)			\
			bgraph_bipart_gp$(OBJ)			\
			bgraph_bipart_ml$(OBJ)			\
			bgraph_bipart_st$(OBJ)			\
			bgraph_bipart_zr$(OBJ)			\
			bgraph_check$(OBJ)			\
			bgraph_cost$(OBJ)			\
			bgraph_store$(OBJ)			\
			common$(OBJ)				\
			common_context$(OBJ)			\
			common_file$(OBJ)			\
			common_file_compress$(OBJ)		\
			common_file_decompress$(OBJ)		\
			common_integer$(OBJ)			\
			common_memory$(OBJ)			\
			common_string$(OBJ)			\
			common_stub$(OBJ)			\
			common_thread$(OBJ)			\
			common_thread_system$(OBJ)		\
			common_timer$(OBJ)			\
			common_values$(OBJ)			\
			context$(OBJ)				\
			fibo$(OBJ)				\
			gain$(OBJ)				\
			geom$(OBJ)				\
			graph$(OBJ)				\
			graph_base$(OBJ)			\
			graph_band$(OBJ)			\
			graph_check$(OBJ)			\
			graph_clone$(OBJ)			\
			graph_coarsen$(OBJ)			\
			graph_diam$(OBJ)			\
			graph_dump$(OBJ)			\
			graph_ielo$(OBJ)			\
			graph_induce$(OBJ)			\
			graph_io$(OBJ)				\
			graph_io_chac$(OBJ)			\
			graph_io_habo$(OBJ)			\
			graph_io_mmkt$(OBJ)			\
			graph_io_scot$(OBJ)			\
			graph_list$(OBJ)			\
			graph_match$(OBJ)			\
			hall_order_hd$(OBJ)			\
			hall_order_hf$(OBJ)			\
			hall_order_hx$(OBJ)			\
			hgraph$(OBJ)				\
			hgraph_check$(OBJ)			\
			hgraph_dump$(OBJ)			\
			hgraph_induce$(OBJ)			\
			hgraph_order_bl$(OBJ)			\
			hgraph_order_cc$(OBJ)			\
			hgraph_order_cp$(OBJ)			\
			hgraph_order_gp$(OBJ)			\
			hgraph_order_hd$(OBJ)			\
			hgraph_order_hf$(OBJ)			\
			hgraph_order_hx$(OBJ)			\
			hgraph_order_kp$(OBJ)			\
			hgraph_order_nd$(OBJ)			\
			hgraph_order_si$(OBJ)			\
			hgraph_order_st$(OBJ)			\
			hmesh$(OBJ)				\
			hmesh_check$(OBJ)			\
			hmesh_hgraph$(OBJ)			\
			hmesh_induce$(OBJ)			\

=== src/libscotchmetis/CMakeLists.txt ===
## Copyright 2014-2016,2021-2023 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##
############################################################
##                                                        ##
##   AUTHORS    : Cedric LACHAT                           ##
##                Amaury JACQUES                          ##
##                Florent PRUVOST                         ##
##                Marc FUENTES                            ##
##                                                        ##
##   FUNCTION   : Secondary configuration file for CMake  ##
##                                                        ##
##   DATES      : # Version 6.0  : from : 01 sep 2014     ##
##                                 to     01 sep 2021     ##
##                # Version 7.0  : from : 01 sep 2021     ##
##                                 to     28 jul 2025     ##
##                                                        ##
############################################################

####################
#  libScotchMeTiS  #
####################

set_source_files_properties(${GENERATED_INCLUDE_DIR}/scotch.h PROPERTIES GENERATED 1)
set_source_files_properties(${GENERATED_INCLUDE_DIR}/metis.h PROPERTIES GENERATED 1)

# metis.h
add_custom_command(OUTPUT ${GENERATED_INCLUDE_DIR}/metis.h
  COMMAND $<TARGET_FILE:dummysizes> ${CMAKE_CURRENT_SOURCE_DIR}/library_metis.h ${GENERATED_INCLUDE_DIR}/metis.h DEPENDS dummysizes
  DEPENDS library_metis.h
  COMMENT "Generating metis.h")

add_custom_target(metis_h
  DEPENDS "${GENERATED_INCLUDE_DIR}/metis.h")

# metisf.h
add_custom_command(OUTPUT ${GENERATED_INCLUDE_DIR}/metisf.h
  COMMAND $<TARGET_FILE:dummysizes> ${CMAKE_CURRENT_SOURCE_DIR}/library_metis_f.h ${GENERATED_INCLUDE_DIR}/metisf.h DEPENDS dummysizes
  DEPENDS library_metis_f.h
  COMMENT "Generating metisf.h")

add_custom_target(metisf_h
  DEPENDS "${GENERATED_INCLUDE_DIR}/metisf.h")

# libScotchMeTiS
foreach(version 3 5)
  add_library(scotchmetisv${version}
    metis_graph_order.c
    metis_graph_order_f.c
    metis_graph_part.c
    metis_graph_part_f.c
    metis_graph_dual.c
    metis_graph_dual_f.c
    metis_graph_part_dual.c
    metis_graph_part_dual_f.c
    metis_options.c
    metis_options_f.c
    ${LIBSCOTCH_INCLUDE_DIR}/module.h
    ${LIBSCOTCH_INCLUDE_DIR}/common.h
    ${GENERATED_INCLUDE_DIR}/scotch.h
    ${GENERATED_INCLUDE_DIR}/metis.h
    ${GENERATED_INCLUDE_DIR}/metisf.h)

  set_target_properties(scotchmetisv${version} PROPERTIES VERSION ${SCOTCH_VERSION_LONG}
    SOVERSION ${SCOTCH_VERSION}.${SCOTCH_RELEASE})
  target_compile_definitions(scotchmetisv${version} PUBLIC SCOTCH_METIS_VERSION=${version})
  if(SCOTCH_METIS_PREFIX)
    target_compile_definitions(scotchmetisv${version} PUBLIC SCOTCH_METIS_PREFIX)
  endif()

  target_include_directories(scotchmetisv${version} PRIVATE
    $<BUILD_INTERFACE:${LIBSCOTCH_INCLUDE_DIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<BUILD_INTERFACE:${GENERATED_INCLUDE_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)

  target_link_libraries(scotchmetisv${version} PRIVATE scotch)
  if(NOT "${LIBSCOTCHERR}" STREQUAL "")
    target_link_libraries(scotchmetisv${version} PRIVATE ${LIBSCOTCHERR})
  endif()

  add_dependencies(scotchmetisv${version} scotch_h metisf_h)
  if(INSTALL_METIS_HEADERS)
    set_target_properties(scotchmetisv${version} PROPERTIES PUBLIC_HEADER "${GENERATED_INCLUDE_DIR}/metis.h;${GENERATED_INCLUDE_DIR}/metisf.h")
  endif()

  if(APPLE)
    set_target_properties(scotchmetisv${version} PROPERTIES LINK_FLAGS "-undefined dynamic_lookup")
  endif()

  # libScotchMeTiS targets install
  install(EXPORT scotchmetisTargets
    COMPONENT libscotch
    FILE scotchmetisTargets.cmake
    NAMESPACE SCOTCH::
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/scotch)
  if(INSTALL_METIS_HEADERS)
    install(TARGETS scotchmetisv${version}
      COMPONENT libscotch
      EXPORT scotchmetisTargets
      RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
      ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
      LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
      PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
  else()
    install(TARGETS scotchmetisv${version}
      COMPONENT libscotch
      EXPORT scotchmetisTargets
      RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
      ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
      LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
  endif()
endforeach(version 3 5)

#########################
#  libPTScotchParMeTiS  #
#########################

if(BUILD_PTSCOTCH)
  set_source_files_properties(${GENERATED_INCLUDE_DIR}/ptscotch.h PROPERTIES GENERATED 1)

  # parmetis.h
  add_custom_command(OUTPUT ${GENERATED_INCLUDE_DIR}/parmetis.h
    COMMAND $<TARGET_FILE:dummysizes> ${CMAKE_CURRENT_SOURCE_DIR}/library_parmetis.h ${GENERATED_INCLUDE_DIR}/parmetis.h DEPENDS dummysizes
    DEPENDS library_parmetis.h
    COMMENT "Generating parmetis.h")

  add_custom_target(parmetis_h
    DEPENDS "${GENERATED_INCLUDE_DIR}/parmetis.h")

  # libPTScotchParMeTiS
  foreach(version 3)
    add_library(ptscotchparmetisv${version}
      parmetis_dgraph_dual.c
      parmetis_dgraph_dual_f.c
      parmetis_dgraph_order.c
      parmetis_dgraph_order_f.c
      parmetis_dgraph_part.c
      parmetis_dgraph_part_f.c
      ${LIBSCOTCH_INCLUDE_DIR}/module.h
      ${LIBSCOTCH_INCLUDE_DIR}/common.h
      ${GENERATED_INCLUDE_DIR}/ptscotch.h
      ${GENERATED_INCLUDE_DIR}/parmetis.h)

    set_target_properties(ptscotchparmetisv${version} PROPERTIES VERSION ${SCOTCH_VERSION_LONG}
      SOVERSION ${SCOTCH_VERSION}.${SCOTCH_RELEASE})
    target_compile_definitions(ptscotchparmetisv${version} PUBLIC SCOTCH_PTSCOTCH SCOTCH_METIS_VERSION=${version})
    if(SCOTCH_METIS_PREFIX)
      target_compile_definitions(ptscotchparmetisv${version} PUBLIC SCOTCH_METIS_PREFIX)
    endif()
    target_include_directories(ptscotchparmetisv${version} PRIVATE
      $<BUILD_INTERFACE:${LIBSCOTCH_INCLUDE_DIR}>
      $<BUILD_INTERFACE:${GENERATED_INCLUDE_DIR}>
      $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
      $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)

    target_link_libraries(ptscotchparmetisv${version} PRIVATE scotch)
    target_link_libraries(ptscotchparmetisv${version} PRIVATE ptscotch)
    target_link_libraries(ptscotchparmetisv${version} PUBLIC MPI::MPI_C)
    if(NOT "${LIBPTSCOTCHERR}" STREQUAL "")
      target_link_libraries(ptscotchparmetisv${version} PRIVATE ${LIBPTSCOTCHERR})
    endif()

    add_dependencies(ptscotchparmetisv${version} ptscotch_h)
    if(INSTALL_METIS_HEADERS)
      set_target_properties(ptscotchparmetisv${version} PROPERTIES PUBLIC_HEADER "${GENERATED_INCLUDE_DIR}/parmetis.h")
    endif()

    if(APPLE)
      set_target_properties(ptscotchparmetisv${version} PROPERTIES LINK_FLAGS "-undefined dynamic_lookup")
    endif()

    # libPTScotchParMeTiS targets install
    install(EXPORT ptscotchparmetisTargets
      COMPONENT libptscotch
      FILE ptscotchparmetisTargets.cmake
      NAMESPACE SCOTCH::
      DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/scotch)

    if(INSTALL_METIS_HEADERS)
      install(TARGETS ptscotchparmetisv${version}
        COMPONENT libptscotch
        EXPORT ptscotchparmetisTargets
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
    else()
      install(TARGETS ptscotchparmetisv${version}
        COMPONENT libptscotch
        EXPORT ptscotchparmetisTargets
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
    endif()
    # adm2dgr
    add_executable(adm2dgr adm2dgr.c adm2dgr.h)
    add_dependencies(adm2dgr parmetis_h)
    target_link_libraries(adm2dgr PRIVATE ptscotchparmetisv${version} ptscotch scotch ptscotcherr)
    install(TARGETS adm2dgr COMPONENT ptscotch RUNTIME DESTINATION ${CMAKE_INSTALL_LIBDIR})
  endforeach(version 3)
endif()

=== src/scotch/Makefile ===
## Copyright 2004,2007-2012,2019,2024 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##

SCOTCHBINDIR		?= ../../bin
SCOTCHINCLUDEDIR	?= ../../include
SCOTCHLIBDIR		?= ../../lib

ifeq ($(strip $(CODENAME)),)
CODENAMEDEF	=
else
CODENAMEDEF	= "-DSCOTCH_CODENAME=\"$(CODENAME)\""
endif

##
##  General inference rules.
##

include ../Makefile.inc

%$(EXE)	:	%$(OBJ)
		 		$(CC) $(CFLAGS) -I$(SCOTCHINCLUDEDIR) -I../libscotch $(<) -o $(@) -L$(SCOTCHLIBDIR) -l$(SCOTCHLIB) -lscotch -l$(SCOTCHLIB)errexit $(LDFLAGS)

%$(OBJ)	:	%.c
				$(CC) $(CFLAGS) -I$(SCOTCHINCLUDEDIR) -I../libscotch $(CODENAMEDEF) -c $(<) -o $(@)

%$(EXE)	:	%.c
				$(CC) $(CFLAGS) -I$(SCOTCHINCLUDEDIR) -I../libscotch $(CODENAMEDEF) $(<) -o $(@) -L$(SCOTCHLIBDIR) -l$(SCOTCHLIB) -lscotch -l$(SCOTCHLIB)errexit $(LDFLAGS)

##
##  Project rules.
##

.PHONY				:	ptscotch	scotch	ptinstall	install	clean	realclean

scotch				:
					$(MAKE) CC="$(CCS)" SCOTCHLIB=scotch	\
					acpl$(EXE)				\
					amk_ccc$(EXE)				\
					amk_fft2$(EXE)				\
					amk_grf$(EXE)				\
					amk_hy$(EXE)				\
					amk_m2$(EXE)				\
					amk_p2$(EXE)				\
					atst$(EXE)				\
					gbase$(EXE)				\
					gcv$(EXE)				\
					gdump$(EXE)				\
					gmap$(EXE)				\
					gmk_hy$(EXE)				\
					gmk_m2$(EXE)				\
					gmk_m3$(EXE)				\
					gmk_msh$(EXE)				\
					gmk_ub2$(EXE)				\
					gmtst$(EXE)				\
					gord$(EXE)				\
					gotst$(EXE)				\
					gout$(EXE)				\
					gpart$(EXE)				\
					gscat$(EXE)				\
					gtst$(EXE)				\
					mcv$(EXE)				\
					mmk_m2$(EXE)				\
					mmk_m3$(EXE)				\
					mord$(EXE)				\
					mtst$(EXE)

ptscotch			:
					$(MAKE) CC="$(CCP)" SCOTCHLIB=ptscotch	\
					dggath$(EXE)				\
					dgmap$(EXE)				\
					dgord$(EXE)				\
					dgpart$(EXE)				\
					dgscat$(EXE)				\
					dgtst$(EXE)

install				:	scotch
					-$(CP) acpl$(EXE) amk_ccc$(EXE) amk_fft2$(EXE) amk_grf$(EXE) amk_hy$(EXE) amk_m2$(EXE) amk_p2$(EXE) atst$(EXE) gbase$(EXE) gcv$(EXE) gdump$(EXE) gmap$(EXE) gmk_hy$(EXE) gmk_m2$(EXE) gmk_m3$(EXE) gmk_msh$(EXE) gmk_ub2$(EXE) gmtst$(EXE) gord$(EXE) gotst$(EXE) gout$(EXE) gpart$(EXE) *gtst$(EXE) gscat$(EXE) mcv$(EXE) mmk_m2$(EXE) mmk_m3$(EXE) mord$(EXE) mtst$(EXE) $(SCOTCHBINDIR)

ptinstall			:	ptscotch
					-$(CP) dggath$(EXE) dgmap$(EXE) dgord$(EXE) dgpart$(EXE) dgscat$(EXE) dgtst$(EXE) $(SCOTCHBINDIR)

clean				:
					-$(RM) *~ *$(OBJ) acpl$(EXE) amk_ccc$(EXE) amk_fft2$(EXE) amk_grf$(EXE) amk_hy$(EXE) amk_m2$(EXE) amk_p2$(EXE) atst$(EXE) gbase$(EXE) gcv$(EXE) gdump$(EXE) *ggath$(EXE) *gmap$(EXE) gmk_hy$(EXE) gmk_m2$(EXE) gmk_m3$(EXE) gmk_msh$(EXE) gmk_ub2$(EXE) gmtst$(EXE) *gord$(EXE) gotst$(EXE) gout$(EXE) *gpart$(EXE) *gscat$(EXE) *gtst$(EXE) mcv$(EXE) mmk_m2$(EXE) mmk_m3$(EXE) mord$(EXE) mtst$(EXE)

realclean			:	clean

##
##  Todo list.
##

acpl$(EXE)			:	acpl.c						\
					../libscotch/module.h				\
					../libscotch/common.h				\
					$(SCOTCHINCLUDEDIR)/scotch.h			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)			\
					$(SCOTCHLIBDIR)/libscotcherrexit$(LIB)		\
					acpl.h

amk_ccc$(EXE)			:	amk_ccc.c					\
					../libscotch/module.h				\
					../libscotch/common.h				\
					$(SCOTCHINCLUDEDIR)/scotch.h			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)			\
					$(SCOTCHLIBDIR)/libscotcherrexit$(LIB)		\
					amk_ccc.h

amk_fft2$(EXE)			:	amk_fft2.c					\
					../libscotch/module.h				\
					../libscotch/common.h				\
					$(SCOTCHINCLUDEDIR)/scotch.h			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)			\
					$(SCOTCHLIBDIR)/libscotcherrexit$(LIB)		\
					amk_fft2.h

amk_grf$(EXE)			:	amk_grf.c					\
					../libscotch/module.h				\
					../libscotch/common.h				\
					$(SCOTCHINCLUDEDIR)/scotch.h			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)			\
					$(SCOTCHLIBDIR)/libscotcherrexit$(LIB)		\
					amk_grf.h

amk_hy$(EXE)			:	amk_hy.c					\
					../libscotch/module.h				\
					../libscotch/common.h				\
					$(SCOTCHINCLUDEDIR)/scotch.h			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)			\
					$(SCOTCHLIBDIR)/libscotcherrexit$(LIB)		\
					amk_hy.h

amk_m2$(EXE)			:	amk_m2.c					\
					../libscotch/module.h				\
					../libscotch/common.h				\
					$(SCOTCHINCLUDEDIR)/scotch.h			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)			\
					$(SCOTCHLIBDIR)/libscotcherrexit$(LIB)		\
					amk_m2.h

amk_p2$(EXE)			:	amk_p2.c					\
					../libscotch/module.h				\
					../libscotch/common.h				\
					$(SCOTCHINCLUDEDIR)/scotch.h			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)			\
					$(SCOTCHLIBDIR)/libscotcherrexit$(LIB)		\
					amk_p2.h

atst$(EXE)			:	atst.c						\
					../libscotch/module.h				\
					../libscotch/common.h				\
					$(SCOTCHINCLUDEDIR)/scotch.h			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)			\
					$(SCOTCHLIBDIR)/libscotcherrexit$(LIB)		\
					atst.h

dggath$(EXE)			:	dggath.c					\
					../libscotch/module.h				\
					../libscotch/common.h				\
					$(SCOTCHINCLUDEDIR)/ptscotch.h			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)			\
					$(SCOTCHLIBDIR)/libptscotch$(LIB)		\
					$(SCOTCHLIBDIR)/libptscotcherrexit$(LIB)	\
					dggath.h

dgmap$(EXE)			:	dgmap.c						\
					../libscotch/module.h				\
					../libscotch/common.h				\
					$(SCOTCHINCLUDEDIR)/ptscotch.h			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)			\
					$(SCOTCHLIBDIR)/libptscotch$(LIB)		\
					$(SCOTCHLIBDIR)/libptscotcherrexit$(LIB)	\
					dgmap.h

dgord$(EXE)			:	dgord.c						\
					../libscotch/module.h				\
					../libscotch/common.h				\
					$(SCOTCHINCLUDEDIR)/ptscotch.h			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)			\
					$(SCOTCHLIBDIR)/libptscotch$(LIB)		\
					$(SCOTCHLIBDIR)/libptscotcherrexit$(LIB)	\
					dgord.h

dgpart$(EXE)			:	dgmap.c						\
					../libscotch/module.h				\
					../libscotch/common.h				\
					$(SCOTCHINCLUDEDIR)/ptscotch.h			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)			\
					$(SCOTCHLIBDIR)/libptscotch$(LIB)		\
					$(SCOTCHLIBDIR)/libptscotcherrexit$(LIB)	\
					dgmap.h
			 		$(CC) $(CFLAGS) -I$(SCOTCHINCLUDEDIR) -I../libscotch $(<) -DSCOTCH_COMPILE_PART -o $(@) -L$(SCOTCHLIBDIR) -lptscotch -lscotch -lptscotcherrexit $(LDFLAGS)

dgscat$(EXE)			:	dgscat.c					\
					../libscotch/module.h				\
					../libscotch/common.h				\
					$(SCOTCHINCLUDEDIR)/ptscotch.h			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)			\
					$(SCOTCHLIBDIR)/libptscotch$(LIB)		\
					$(SCOTCHLIBDIR)/libptscotcherrexit$(LIB)	\
					dgscat.h

dgtst$(EXE)			:	dgtst.c						\
					../libscotch/module.h				\
					../libscotch/common.h				\
					$(SCOTCHINCLUDEDIR)/ptscotch.h			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)			\
					$(SCOTCHLIBDIR)/libptscotch$(LIB)		\
					$(SCOTCHLIBDIR)/libptscotcherrexit$(LIB)	\
					dgtst.h

gbase$(EXE)			:	gbase.c						\
					../libscotch/module.h				\
					../libscotch/common.h				\
					$(SCOTCHINCLUDEDIR)/scotch.h			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)			\
					$(SCOTCHLIBDIR)/libscotcherrexit$(LIB)		\
					gbase.h

gcv$(EXE)			:	gcv.c						\
					../libscotch/module.h				\
					../libscotch/common.h				\
					$(SCOTCHINCLUDEDIR)/scotch.h			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)			\
					$(SCOTCHLIBDIR)/libscotcherrexit$(LIB)		\
					gcv.h

gdump$(EXE)			:	gdump.c						\
					../libscotch/module.h				\
					../libscotch/common.h				\
					$(SCOTCHINCLUDEDIR)/scotch.h			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)			\
					$(SCOTCHLIBDIR)/libscotcherrexit$(LIB)		\
					gdump.h

gmap$(EXE)			:	gmap.c						\
					../libscotch/module.h				\
					../libscotch/common.h				\
					$(SCOTCHINCLUDEDIR)/scotch.h			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)			\
					$(SCOTCHLIBDIR)/libscotcherrexit$(LIB)		\
					gmap.h

gmk_hy$(EXE)			:	gmk_hy.c					\
					../libscotch/module.h				\
					../libscotch/common.h				\
					$(SCOTCHINCLUDEDIR)/scotch.h			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)			\
					$(SCOTCHLIBDIR)/libscotcherrexit$(LIB)		\
					gmk_hy.h

gmk_m2$(EXE)			:	gmk_m2.c					\
					../libscotch/module.h				\
					../libscotch/common.h				\
					$(SCOTCHINCLUDEDIR)/scotch.h			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)			\
					$(SCOTCHLIBDIR)/libscotcherrexit$(LIB)		\
					gmk_m2.h

gmk_m3$(EXE)			:	gmk_m3.c					\
					../libscotch/module.h				\
					../libscotch/common.h				\
					$(SCOTCHINCLUDEDIR)/scotch.h			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)			\
					$(SCOTCHLIBDIR)/libscotcherrexit$(LIB)		\
					gmk_m3.h

gmk_msh$(EXE)			:	gmk_msh.c					\
					../libscotch/module.h				\
					../libscotch/common.h				\
					$(SCOTCHINCLUDEDIR)/scotch.h			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)			\
					$(SCOTCHLIBDIR)/libscotcherrexit$(LIB)		\
					gmk_msh.h

gmk_ub2$(EXE)			:	gmk_ub2.c					\
					../libscotch/module.h				\
					../libscotch/common.h				\
					$(SCOTCHINCLUDEDIR)/scotch.h			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)			\
					$(SCOTCHLIBDIR)/libscotcherrexit$(LIB)		\
					gmk_ub2.h

gmtst$(EXE)			:	gmtst.c						\
					../libscotch/module.h				\
					../libscotch/common.h				\
					$(SCOTCHINCLUDEDIR)/scotch.h			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)			\
					$(SCOTCHLIBDIR)/libscotcherrexit$(LIB)		\
					gmtst.h

gord$(EXE)			:	gord.c						\
					../libscotch/module.h				\
					../libscotch/common.h				\
					$(SCOTCHINCLUDEDIR)/scotch.h			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)			\
					$(SCOTCHLIBDIR)/libscotcherrexit$(LIB)		\
					gord.h

gotst$(EXE)			:	gotst.c						\
					../libscotch/module.h				\
					../libscotch/common.h				\
					$(SCOTCHINCLUDEDIR)/scotch.h			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)			\
					$(SCOTCHLIBDIR)/libscotcherrexit$(LIB)		\
					gotst.h

gout$(EXE)			:	gout_c.c					\
					gout_o.c					\
					$(SCOTCHINCLUDEDIR)/scotch.h			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)			\
					$(SCOTCHLIBDIR)/libscotcherrexit$(LIB)
					$(CC) $(CFLAGS) -I../libscotch -I$(SCOTCHINCLUDEDIR) gout_c.c gout_o.c -o $(@) -L$(SCOTCHLIBDIR) -lscotch -lscotcherrexit $(LDFLAGS)

gpart$(EXE)			:	gmap.c						\
					../libscotch/module.h				\
					../libscotch/common.h				\
					$(SCOTCHINCLUDEDIR)/scotch.h			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)			\
					$(SCOTCHLIBDIR)/libscotcherrexit$(LIB)		\
					gmap.h
			 		$(CC) $(CFLAGS) -I$(SCOTCHINCLUDEDIR) -I../libscotch $(<) -DSCOTCH_COMPILE_PART -o $(@) -L$(SCOTCHLIBDIR) -lscotch -lscotcherrexit $(LDFLAGS)

gscat$(EXE)			:	gscat.c						\
					../libscotch/module.h				\
					../libscotch/common.h				\
					$(SCOTCHINCLUDEDIR)/scotch.h			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)			\
					$(SCOTCHLIBDIR)/libscotcherrexit$(LIB)		\
					gscat.h

gtst$(EXE)			:	gtst.c						\
					../libscotch/module.h				\
					../libscotch/common.h				\
					$(SCOTCHINCLUDEDIR)/scotch.h			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)			\

=== debian/changelog ===
scotch (7.0.9-1exp1) experimental; urgency=medium

  * New upstream release.
    - supports dual graphs in parallel.
      Provides ParMETIS_V3_Mesh2Dual. Closes: #506033.
    - deprecates debian patch parallel_tests.patch
    - applies install_missing_exe.patch
  * libscotch-dev Depends: libscotcherr-dev. Likewise libptscotch-dev.
  * libscotcherr-dev Breaks, Replaces: libscotch-dev (<< 7.0.8-1~)
    Likewise for libptscotcherr-dev. Closes: #1110401.
  * update debian patches
    - update standalone_tests.patch for gdump
    - add install_exe_in_bin.patch installs adm2dgr* (executable
      for ptscotch/parmetis) to bin not lib
    - add revert_internal_headers_in_tests_81cb036f.diff to revert
      commit 81cb036f (4/7/2025), which included internal headers in
      tests preventing them from building standalone.

 -- Drew Parsons <dparsons@debian.org>  Mon, 01 Sep 2025 04:30:32 +0200

=== debian/control ===
Source: scotch
Section: math
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: "Adam C. Powell, IV" <hazelsct@debian.org>,
 Andreas Tille <tille@debian.org>,
 Drew Parsons <dparsons@debian.org>
Build-Depends: debhelper-compat (= 13),
    cmake,
    gfortran | fortran-compiler,
    bison, flex,
    zlib1g-dev,
    libbz2-dev,
    liblzma-dev,
    chrpath,
    mpi-default-dev (>= 1.17), mpi-default-bin
Standards-Version: 4.7.0
Vcs-Git: https://salsa.debian.org/science-team/scotch.git
Vcs-Browser: https://salsa.debian.org/science-team/scotch
Homepage: http://www.labri.fr/perso/pelegrin/scotch/

Package: scotch
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: programs and libraries for graph, mesh and hypergraph partitioning
 Its purpose is to apply graph theory, with a divide and conquer
 approach, to scientific computing problems such as graph and mesh
 partitioning, static mapping, and sparse matrix ordering, in
 application domains ranging from structural mechanics to operating
 systems or bio-chemistry.
 .
 The SCOTCH distribution is a set of programs and libraries which
 implement the static mapping and sparse matrix reordering algorithms
 developed within the SCOTCH project.
 .
 SCOTCH has many interesting features:
 .
 o Its capabilities can be used through a set of stand-alone programs
 as well as through the libSCOTCH library, which offers both C and
 Fortran interfaces.
 .
 o It provides algorithms to partition graph structures, as well as
 mesh structures defined as node-element bipartite graphs and which
 can also represent hypergraphs.
 .
 o It can map any weighted source graph onto any weighted target
 graph. The source and target graphs may have any topology, and their
 vertices and edges may be weighted. Moreover, both source and target
 graphs may be disconnected. This feature allows for the mapping of
 programs onto disconnected subparts of a parallel architecture made
 up of heterogeneous processors and communication links.
 .
 o It computes amalgamated block orderings of sparse matrices, for
 efficient solving using BLAS routines.
 .
 o Its running time is linear in the number of edges of the source
 graph, and logarithmic in the number of vertices of the target graph
 for mapping computations.
 .
 o It can handle indifferently graph and mesh data structures created
 within C or Fortran programs, with array indices starting from 0 or
 1.
 .
 o It offers extended support for adaptive graphs and meshes through
 the handling of disjoint edge arrays.
 .
 o It is dynamically parametrizable thanks to strategy strings that
 are interpreted at run-time.
 .
 o It uses system memory efficiently, to process large graphs and
 meshes without incurring out-of-memory faults;
 .
 o It is highly modular and documented. Since it has been released
 under the CeCILL-C free/libre software license, it can be used as a
 testbed for the easy and quick development and testing of new
 partitioning and ordering methods.
 .
 o It can be easily interfaced to other programs. The programs
 comprising the SCOTCH project have been designed to run in
 command-line mode without any interactive prompting, so that they can
 be called easily from other programs by means of system() or popen()
 calls, or piped together on a single command line. Moreover, vertex
 labeling capabilities allow for easy renumbering of vertices.
 .
 o It provides many tools to build, check, and display graphs, meshes
 and matrix patterns.
 .
 o It is written in C and uses the POSIX interface, which makes it
 highly portable. PT-SCOTCH uses the MPI interface, and optionally the
 POSIX threads.

Package: ptscotch
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: MPI programs and libraries for graph, mesh and hypergraph partitioning
 PT-SCOTCH is the MPI version of scotch, which is a set of programs and
 libraries which implement the static mapping and sparse matrix reordering
 algorithms developed within the SCOTCH project.

Package: libscotch-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libscotcherr-dev (= ${binary:Version}), libscotch-7.0c (= ${binary:Version}), mpi-default-dev, zlib1g-dev, ${shlibs:Depends}, ${misc:Depends}
Description: programs and libraries for graph, mesh and hypergraph partitioning
 Headers and libraries package for scotch, which is a set of programs and
 libraries which implement the static mapping and sparse matrix reordering
 algorithms developed within the SCOTCH project.

Package: libptscotch-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libptscotcherr-dev (= ${binary:Version}), libptscotch-7.0c (= ${binary:Version}), libscotch-dev (= ${binary:Version}), mpi-default-dev, zlib1g-dev, ${misc:Depends}
Description: MPI programs and libraries for graph, mesh and hypergraph partitioning
 Headers and libraries package for PT-SCOTCH, the MPI version of scotch, which
 is a set of programs and libraries which implement the static mapping and
 sparse matrix reordering algorithms developed within the SCOTCH project.

Package: scotch-64
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: programs and libraries for 64-bit graph, mesh and hypergraph partitioning
 The SCOTCH distribution is a set of programs and libraries which
 implement the static mapping and sparse matrix reordering algorithms
 developed within the SCOTCH project.
 .
 This package provides scotch with 64-bit indexing (IDXSIZE=64) for
 SCOTCH_Idx but standard 32-bit integers for SCOTCH_Num.

Package: ptscotch-64
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: MPI programs and libraries for 64-bit graph, mesh and hypergraph partitioning
 PT-SCOTCH is the MPI version of scotch, which is a set of programs and
 libraries which implement the static mapping and sparse matrix reordering
 algorithms developed within the SCOTCH project.
 .
 This package provides scotch with 64-bit indexing (IDXSIZE=64) for
 SCOTCH_Idx but standard 32-bit integers for SCOTCH_Num.

Package: libscotch-64-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libscotcherr-dev (= ${binary:Version}), libscotch-64-7.0 (= ${binary:Version}), mpi-default-dev, zlib1g-dev, ${shlibs:Depends}, ${misc:Depends}
Description: programs and libraries for 64-bit graph, mesh and hypergraph partitioning
 Headers and libraries package for scotch, which is a set of programs and
 libraries which implement the static mapping and sparse matrix reordering
 algorithms developed within the SCOTCH project.
 .
 This package provides scotch with 64-bit indexing (IDXSIZE=64) for
 SCOTCH_Idx but standard 32-bit integers for SCOTCH_Num.

Package: libptscotch-64-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libptscotcherr-dev (= ${binary:Version}), libptscotch-64-7.0 (= ${binary:Version}), libscotch-dev (= ${binary:Version}), mpi-default-dev, zlib1g-dev, ${misc:Depends}
Description: MPI programs and libraries for graph, mesh and hypergraph partitioning
 Headers and libraries package for PT-SCOTCH, the MPI version of scotch, which
 is a set of programs and libraries which implement the static mapping and
 sparse matrix reordering algorithms developed within the SCOTCH project.
 .
 This package provides scotch with 64-bit indexing (IDXSIZE=64) for
 SCOTCH_Idx but standard 32-bit integers for SCOTCH_Num.

Package: scotch-64i
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: programs and libraries for 64-bit graph, mesh and hypergraph partitioning
 The SCOTCH distribution is a set of programs and libraries which
 implement the static mapping and sparse matrix reordering algorithms
 developed within the SCOTCH project.
 .
 This package provides scotch with both 64-bit indexing and integers
 (IDXSIZE=64 and INTSIZE=64).

Package: ptscotch-64i
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: MPI programs and libraries for 64-bit graph, mesh and hypergraph partitioning
 PT-SCOTCH is the MPI version of scotch, which is a set of programs and
 libraries which implement the static mapping and sparse matrix reordering
 algorithms developed within the SCOTCH project.
 .
 This package provides ptscotch with both 64-bit indexing and integers.
 (IDXSIZE=64 and INTSIZE=64).

Package: libscotch-64i-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libscotcherr-dev (= ${binary:Version}), libscotch-64-7.0 (= ${binary:Version}), mpi-default-dev, zlib1g-dev, ${shlibs:Depends}, ${misc:Depends}
Description: programs and libraries for 64-bit graph, mesh and hypergraph partitioning
 Headers and libraries package for scotch, which is a set of programs and
 libraries which implement the static mapping and sparse matrix reordering
 algorithms developed within the SCOTCH project.
 .
 This package provides libscotch with both 64-bit indexing and integers
 (IDXSIZE=64 and INTSIZE=64).

Package: libptscotch-64i-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libptscotcherr-dev (= ${binary:Version}), libptscotch-64-7.0 (= ${binary:Version}), libscotch-dev (= ${binary:Version}), mpi-default-dev, zlib1g-dev, ${misc:Depends}
Description: MPI programs and libraries for graph, mesh and hypergraph partitioning
 Headers and libraries package for PT-SCOTCH, the MPI version of scotch, which
 is a set of programs and libraries which implement the static mapping and
 sparse matrix reordering algorithms developed within the SCOTCH project.
 .
 This package provides libptscotch with both 64-bit indexing and integers
 (IDXSIZE=64 and INTSIZE=64).

Package: libscotcherr-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libscotcherr-7.0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Breaks: libscotch-dev (<< 7.0.8-1~)
Replace: libscotch-dev (<< 7.0.8-1~)
Description: libraries for graph, mesh and hypergraph partitioning (error handling)
 Headers and libraries package for scotch, which is a set of programs and
 libraries which implement the static mapping and sparse matrix reordering
 algorithms developed within the SCOTCH project.
 .
 This package provides development files for the common libscotcherr
 and libscotcherrexit libraries used for error handling by scotch.

Package: libptscotcherr-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libptscotcherr-7.0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Breaks: libptscotch-dev (<< 7.0.8-1~)
Replace: libptscotch-dev (<< 7.0.8-1~)
Description: libraries for graph, mesh and hypergraph partitioning (error handling)
 Headers and libraries package for scotch, which is a set of programs and
 libraries which implement the static mapping and sparse matrix reordering
 algorithms developed within the SCOTCH project.
 .
 This package provides development files for the common libptscotcherr
 and libptscotcherrexit libraries used for error handling by ptscotch.

Package: libscotchmetis-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libscotch-dev (= ${binary:Version}), libscotch-7.0c (= ${binary:Version}),
 ${misc:Depends}
Conflicts: libmetis-dev, libparmetis-dev
Replaces: libmetis-dev
Description: programs and libraries for graph, mesh and hypergraph partitioning
 Scotch/Metis compatility interface, providing a free implementation of the
 Metis system for graph partitioning and sparse matrix reordering.

Package: libscotchparmetis-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libptscotch-dev (= ${binary:Version}), libptscotch-7.0c (= ${binary:Version}),
 ${misc:Depends}
Conflicts: libparmetis-dev
Replaces: libparmetis-dev
Description: programs and libraries for graph, mesh and hypergraph partitioning
 Scotch/ParMetis compatility interface, providing a free implementation of the
 ParMetis system for parallel graph partitioning and sparse matrix reordering.

Package: libscotchmetis-64-dev

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


include /usr/share/dpkg/architecture.mk

empty :=
space := $(empty)$(empty)

# int = default build (using int, giving 32-bit indexing)
# int64 = 64-bit indexing only (with standard integers)
# int64i = full 64-bit integers and indexing
BIT_BUILDS = int int64 int64i

BUILDDIR_BASE=obj-$(DEB_HOST_MULTIARCH)

# Add here any variable or target overrides you need.
# where sources are
DEB_SRCDIR = $(CURDIR)/src

# no check for this software
#DEB_MAKE_CHECK_TARGET :=

CMAKE_FLAGS_COMMON = -DBUILD_SHARED_LIBS=ON \
			-DUSE_ZLIB=ON \
			-DUSE_BZ2=ON \
			-DUSE_LZMA=ON \
			-DTHREADS=ON \
			-DMPI_THREAD_MULTIPLE=ON \
			-DSCOTCH_DETERMINISTIC=FIXED_SEED

SCOTCH_CONFIG_CFLAGS = -DSCOTCH_PTHREAD_NUMBER=2 \
			-DCOMMON_PTHREAD_FILE

# hurd does not have POSIX time and therefore needs sys/time.h to define struct timeval
# hurd does not support pthread_setaffinity_np (-DSCOTCH_PTHREAD_AFFINITY_LINUX)
ifeq ($(DEB_BUILD_ARCH_OS),hurd)
  SCOTCH_CONFIG_CFLAGS += -DHAVE_SYS_TIME_H=ON
endif

# By default, halt on test (check) failures. But,
# - hurd times out on buildd during build-time checks
# - m68k segfaults inside the qemu emulator used for builds
# - powerpcspe segfaults on test_scotch_graph_order in INTSIZE64
# so don't halt on test failures on these arches.
# In fact don't run tests at all on hurd.
ifeq ($(DEB_HOST_ARCH_OS),hurd)
  HALT_ON_TEST_ERROR = no
  SKIP_TESTS = yes
else ifeq ($(DEB_HOST_ARCH),m68k)
  HALT_ON_TEST_ERROR = no
else ifeq ($(DEB_HOST_ARCH),powerpcspe)
  HALT_ON_TEST_ERROR = no
else
  HALT_ON_TEST_ERROR = yes
endif
ifeq (nocheck,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
  SKIP_TESTS = yes
endif


# mord_ship001 fails with full 64-bit support (_64i) on some architectures
# skip the flakey test on these arches
64i_SKIP_FLAKEY_TESTS_ARCH_LIST = armel armhf ppc64el s390x alpha powerpc ppc64
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(64i_SKIP_FLAKEY_TESTS_ARCH_LIST)$(space)))
  CMAKE_EXTRA_FLAGS_64i = -DSKIP_FLAKEY_TESTS=ON
endif


DEB_STRIPPED_UPSTREAM_VERSION = $(shell echo $(DEB_UPSTREAM_VERSION) | sed -n -e 's/\.dfsg.*$$//p')
SCOTCH_VERSION=$(DEB_STRIPPED_UPSTREAM_VERSION)

export PRTE_MCA_plm_ssh_agent=/bin/false      # workaround to start MPI-applications in chroot
export OMPI_MCA_btl_tcp_if_include=lo         # avoid complaints about unreachable pairing between local and remote
export PRTE_MCA_rmaps_default_mapping_policy=:oversubscribe  # oversubscribing allows s390x to use hardware threads

export DEB_CFLAGS_MAINT_APPEND = $(SCOTCH_CONFIG_CFLAGS)

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	for BITS in $(BIT_BUILDS); do \
            if [ $$BITS = int64 ]; then \
                LIBNAME_SUFFIX=_64; \
                bit_flags="-DIDXSIZE=64 -DSCOTCH_SONAME_SUFFIX=$${LIBNAME_SUFFIX}"; \
            elif [ $$BITS = int64i ]; then \
                LIBNAME_SUFFIX=_64i; \
                bit_flags="-DINTSIZE=64 -DIDXSIZE=64 -DSCOTCH_SONAME_SUFFIX=$${LIBNAME_SUFFIX} $(CMAKE_EXTRA_FLAGS_64i)"; \
            else \
                LIBNAME_SUFFIX=; \
                bit_flags=; \
            fi; \
            echo "Configure for scotch $$BITS" ; \
	    dh_auto_configure --builddirectory=$(BUILDDIR_BASE)$${LIBNAME_SUFFIX} -- $(CMAKE_FLAGS_COMMON) $${bit_flags}; \
	done

override_dh_auto_build:
	set -e; \
	for BITS in $(BIT_BUILDS); do \
            if [ $$BITS = int64 ]; then \
                LIBNAME_SUFFIX=_64; \
            elif [ $$BITS = int64i ]; then \
                LIBNAME_SUFFIX=_64i; \
            else \
                LIBNAME_SUFFIX=; \
            fi; \
	   echo "Compiling for $$BITS"; \
	   dh_auto_build -O--parallel --builddirectory=$(BUILDDIR_BASE)$${LIBNAME_SUFFIX}; \
	done

override_dh_auto_test:
	set -e; \
	for BITS in $(BIT_BUILDS); do \
            if [ $$BITS = int64 ]; then \
                LIBNAME_SUFFIX=_64; \
            elif [ $$BITS = int64i ]; then \
                LIBNAME_SUFFIX=_64i; \
            else \
                LIBNAME_SUFFIX=; \
            fi; \
            echo "Testing for $$BITS" ; \
	    dh_auto_test -O--parallel --builddirectory=$(BUILDDIR_BASE)$${LIBNAME_SUFFIX}; \
	done

override_dh_auto_install:
	set -e; \
	for BITS in $(BIT_BUILDS); do \
            if [ $$BITS = int64 ]; then \
                LIBNAME_SUFFIX=_64; \
            elif [ $$BITS = int64i ]; then \
                LIBNAME_SUFFIX=_64i; \
            else \
                LIBNAME_SUFFIX=; \
            fi; \
            echo "Installing for $$BITS" ; \
	    dh_auto_install -O--parallel --builddirectory=$(BUILDDIR_BASE)$${LIBNAME_SUFFIX}; \
	done

override_dh_installman:
	dh_installman
	mv debian/scotch/usr/share/man/man1/gmap.1 debian/scotch/usr/share/man/man1/scotch_gmap.1
	mv debian/scotch/usr/share/man/man1/gbase.1 debian/scotch/usr/share/man/man1/scotch_gbase.1
	(cd debian/scotch/usr/share/man/man1 && ln -sf scotch_gmap.1.gz scotch_gpart.1.gz)

execute_after_dh_auto_clean:
	for BITS in $(BIT_BUILDS); do \
            if [ $$BITS = int64 ]; then \
                LIBNAME_SUFFIX=_64; \
            elif [ $$BITS = int64i ]; then \
                LIBNAME_SUFFIX=_64i; \
            else \
                LIBNAME_SUFFIX=; \
            fi; \
	   rm -rf $(BUILDDIR_BASE)$${LIBNAME_SUFFIX}; \
	done
